<?php
/*
Plugin Name: Cross-linker
Plugin URI: https://wordpress.org/plugins/cross-linker/
Description: Plugin which allows automatic linking of predefined words to any document on the web, be it within own WordPress website or to any external address.
Version: 3.0.1.9
Author: Jan Hvizdak
Author URI: https://www.janhvizdak.com/
*/


/*  Copyright 2020  Jan Hvizdak  (email : postmaster@aqua-fish.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

	global $wpdb;
	$crosslinker_version = "3.0.1.9";

	if (! defined('CLNKR_PAGER') )
		define("CLNKR_PAGER",				"clnkr_pagings");				//ako sa vola premenna, ktorou menim strankovanie
		
	if (! defined('DEFAULT_REC_PER_PAGE') )
		define("DEFAULT_REC_PER_PAGE",	1000);							//kolko je maximalny pocet zaznamov na stranku so slovami/linkami
		
	if (! defined('CLNKR_COOKIE_PAGING') )
		define("CLNKR_COOKIE_PAGING",		"clnkr_cpage");				//nazov cookie pre spravu stranovania
		
	if (! defined('CLNKR_COOKIE_ORDBY') )	
		define("CLNKR_COOKIE_ORDBY",		"clnkr_ordby");				//nazov cookie pre zotriedenie
		
	if (! defined('CLNKR_COOKIE_STATS') )
		define("CLNKR_COOKIE_STATS",		"clnkr_showstats");			//nazov cookie pre statistiky toho ktoreho slova
		
	if (! defined('CLNKR_SEARCH_STRING') )
		define("CLNKR_SEARCH_STRING",		"clnkr_search_string");		//ako sa vola premenna, kde vymedzim vysledky vyhladavania
		
	if (! defined('CLNKR_VISIBLE_TYPE') )
		define("CLNKR_VISIBLE_TYPE",		"clnkr_visible_links");		//ako sa vola premenna, kde sa definuje, co sa zobrazi v admin menu
		
	if (! defined('CLNKR_INVISIBLE_TYPE') )
		define("CLNKR_INVISIBLE_TYPE",	"clnkr_invisible_links");	//ako sa vola premenna, kde sa definuje, co sa zobrazi v admin menu
		
	if (! defined('CLNKR_TRUNC_STATS_WORD') )
		define("CLNKR_TRUNC_STATS_WORD",	"truncate_stats_word");		//ako sa vola premenna, kde definujeme mazanie statistik pre slovo
		
	if (! defined('CLNKR_TRUNC_STATS_ALL') )
		define("CLNKR_TRUNC_STATS_ALL",	"truncate_stats_all");		//ako sa vola premenna, kde definujeme mazanie statistik vsetkych slov
		
	if (! defined('CLNKR_PROCESSDIR') )
		define("CLNKR_PROCESSDIR",			"/assets/process/");			//cesta k ajax skriptom php
		
	if (! defined('CLNKR_IMGDIR') )
		define("CLNKR_IMGDIR",				"/assets/img/");				//cesta k obrazkom
		
	if (! defined('CLNKR_DELHTML') )
		define("CLNKR_DELHTML",				"deleteLangEl_");				//zaciatok id elementu pre zmazanie jazyka
		
	if (! defined('CLNKR_DEACTLAN') )
		define("CLNKR_DEACTLAN",			"deactLangEl_");				//zaciatok id elementu pre deaktivaciu jazyka
		
	if (! defined('CLNKR_MODAREA') )
		define("CLNKR_MODAREA",				"hdiv_style_clnkr");			//nazov elementu, ktory sa ma zobrazit pri kliknuti na modify
		
	if (! defined('CLNKR_DELETETERM') )
		define("CLNKR_DELETETERM",			"deleteTermEl_");				//zaciatok id elementu pre zmazanie prelinkovaneho slova

	if(function_exists('add_action'))
		add_action('admin_menu', 'crosslinker_add_pages');

	function crosslinker_add_pages() {
		add_management_page('Cross-Linker Plug-In Management', 'Cross-Linker', 8, 'crosslinker', 'cross_linker');
	}

	$jal_db_version_x     = "1.0";
	$table_crosslink_main = "interlinker";				//opt
	$table_crosslink_tags = "interlinker_special_chars";		//opt
	$table_crosslink_chars= "interlinker_divide_chars";		//opt
	$table_crosslink_setts= "interlinker_settings";			//opt
	$table_crosslink_attrb= "interlinker_attributes";		//opt
	$table_crosslink_lngs = "interlinker_multilang";		//opt
	$table_crosslink_wdlng= "interlinker_lng_wds";			//opt
	$table_crosslink_stts1= "interlinker_stats_main";		//vseobecne statistiky
	$table_crosslink_stts2= "interlinker_stats_details";		//detailne statistiky

	$table_backups        = "interlinker_backups";			//opt
	$table_backup_main    = "interlinker_backup_main";
	$table_backup_chars   = "interlinker_special_chars";
	$table_backup_tags    = "interlinker_divide_chars";
	$table_backup_setting = "interlinker_settings";
	$table_backup_attrb   = "interlinker_attributes";
	$table_backup_langs   = "interlinker_multilang";
	$table_backup_wdlng   = "interlinker_lng_wds";

	$cross_folder     = @str_replace('\\', '/', dirname(__FILE__));
	$cross_thisfolder = @explode('/', $cross_folder);

	class clnkrClass {
		const STATS_VALID_PEROD = "7 DAY";		//ako dlho drzat statistiky o stranke pred updatnutim
		const STATS_VALID_PERSH = "7 days";		//na vypis iba
		const MAX_TRIES_SQLSAFE = 100;			//kolkokrat maximalne osetrit vstup pred abortom

		//tabulky
		const TBL_MAIN = "interlinker";			//hlavna tabulka s datami o linkach a slovach
		const TBL_TAGS = "interlinker_special_chars";	//tabulka s tagmi pre slova
		const TBL_ATTR = "interlinker_attributes";	//tabulka s atributmi
		const TBL_CHAR = "interlinker_divide_chars";	//tabulka s extra charaktermi
		const TBL_SETT = "interlinker_settings";	//tabulka s nastaveniami
		const TBL_LANG = "interlinker_multilang";	//tabulka s jazykmi
		const TBL_LNDT = "interlinker_lng_wds";		//tabulka s detailmi o jazykoch
		const TBL_STAT = "interlinker_stats_main";	//tabulka so zakladnymi statistikami o tom, co kam ukazuje
		const TBL_STDT = "interlinker_stats_details";	//tabulka s detailami o tom, ktore slovo je kde prelinkovane
		const TBL_BKPM = "interlinker_backup_main";	//hlavna tabulka so zalohami
		const DEBUG		= FALSE;								//debugovanie
		const DOGE		= "D8op2CAfYL7GggEbZhAh3AeEgzQq76HkoY";		//adresa na dogecoin dotacie
		const BTC		= "3Ejyg8aKLyNAPMhEFsBCZdA1Jo8CaB2PDZ";		//adresa na btc dotacie

		//vytvorenie tabuliek
		public function table_interlinker_install() {
			global $wpdb, $jal_db_version_x;
			
			if( !isset( $drop ) )
				$drop = array();

			//ak sme zamenili nazvy tabuliek pre divide a special, zmazeme ich a dropneme - potom sa automaticky vytvoria!
			$sql = "SELECT COUNT(*) FROM ".$wpdb->prefix. self::TBL_TAGS.";";
			if($wpdb->get_var($sql)>1)
				$drop[] = "DROP TABLE ".$wpdb->prefix.self::TBL_TAGS.";";
			
			$sql = "SHOW COLUMNS FROM ".$wpdb->prefix.self::TBL_CHAR." WHERE lower(Field) = 'characters';";
			if($wpdb->get_var($sql)!='')
				$drop[] = "DROP TABLE ".$wpdb->prefix.self::TBL_CHAR.";";

			if( !is_array( $drop ) )
				$drop = array();
			$drop_count = count($drop);
			for($i=0;$i<$drop_count;$i++)
				$wpdb->query($drop[$i]); 
			unset($drop);

			//najprv osetrime engine, ak je myisam
			$sql = "SHOW TABLE STATUS FROM ".DB_NAME." WHERE Name LIKE '".$wpdb->prefix."interlinker%';";
			$zaznamy = $wpdb->get_results($sql);
			if($zaznamy) {
				foreach ( $zaznamy as $zaznam ) {
					if($this->strtolower_utf8($zaznam->Engine)!="innodb")
						$wpdb->query("ALTER TABLE ".$zaznam->Name." ENGINE = 'InnoDB';");
					}
			}

			$table_name = $wpdb->prefix . self::TBL_MAIN;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id smallint(11) NOT NULL auto_increment, 
link_word varchar(250) NOT NULL, 
link_url text NOT NULL, 
visible int(2) NOT NULL, 
PRIMARY KEY  (id), 
KEY link_word (link_word), 
KEY visible (visible) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );

				add_option("jal_db_version", $jal_db_version_x);
			}

			//ak neexistuje index, vytvorime
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'id' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD PRIMARY KEY ( `id` ) ;");
				$wpdb->query("ALTER TABLE `" . $table_name . "` CHANGE `id` `id` SMALLINT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ;");
			}
				
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'visible' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD INDEX ( `visible` ) ;");
			}
				
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'link_word' ; ";
			if( $wpdb->get_var( $sql, 2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD INDEX ( `link_word` ) ;");
			}

			$table_name = $wpdb->prefix . self::TBL_CHAR;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id smallint(11) NOT NULL auto_increment, 
tag_1  varchar(250) NOT NULL, 
tag_2  varchar(250) NOT NULL, 
PRIMARY KEY  (id), 
KEY tag_1 (tag_1), 
KEY tag_2 (tag_2) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );

				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '>' , '<' );";
				$wpdb->query( $sql );
					
				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '</h' , '<h' );";
				$wpdb->query( $sql );
					
				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '</strong' , '<strong' );";
				$wpdb->query( $sql );
					
				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '</b' , '<b' );";
				$wpdb->query( $sql );
					
				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '</a' , '<a' );";
				$wpdb->query( $sql );

				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , '</textarea' , '<textarea' );";
				$wpdb->query( $sql );
			}

			//REMOVE duplicates if some are present
			$sql     = "SELECT tag_2, tag_1, id FROM " . $table_name . " ORDER BY id ASC;";
			$zaznamy = $wpdb->get_results($sql);
			if($zaznamy) {
				foreach ( $zaznamy as $zaznam ) {
					$delete = "DELETE FROM " . $table_name . " WHERE (tag_2 LIKE '" . $zaznam->tag_2 . "') AND (tag_1 LIKE '" . $zaznam->tag_1 . "') AND (id > " . $zaznam->id . ");";
					$wpdb->query( $delete );
				}
			}

			$table_name = $wpdb->prefix . self::TBL_TAGS;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id smallint(11) NOT NULL auto_increment, 
characters text NOT NULL, 
PRIMARY KEY  (id) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );

				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , ' ; . , ) ( - : & > < ? ! * / +' );";
				$wpdb->query( $sql );
			}

			//FIX wrongly inserted rows on some mysql installations
			$sql = "DELETE FROM " . $table_name . " WHERE id > 1;";
			$wpdb->query( $sql );

			$table_name = $wpdb->prefix . self::TBL_SETT;
			if($this->tbl_exist( $table_name ) == 0)	{
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id smallint(11) NOT NULL auto_increment, 
setting text NOT NULL, 
value text NOT NULL, 
PRIMARY KEY  (id) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );

				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , 'link_to_thrusites' , '0' );";
				$wpdb->query( $sql );
				$sql = "INSERT INTO " . $table_name . " values ( 'NULL' , 'link_first_word' , '0' );";
				$wpdb->query( $sql );
			}

			//REMOVE duplicates if some are present
			$sql     = "SELECT id, setting FROM " . $table_name . " ORDER BY id ASC;";
			$zaznamy = $wpdb->get_results($sql);
			if($zaznamy) {
				foreach ( $zaznamy as $zaznam ) {
					$delete = "DELETE FROM " . $table_name . " WHERE (setting LIKE '".$zaznam->setting."') AND (id > '".$zaznam->id."');";
					$wpdb->query($delete);
				}
			}

			$table_name = $wpdb->prefix . self::TBL_LANG;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id int(11) NOT NULL AUTO_INCREMENT, 
lang_def varchar(200) COLLATE utf8_unicode_ci NOT NULL, 
visible enum('0','1') COLLATE utf8_unicode_ci NOT NULL, 
PRIMARY KEY (id), 
KEY lang_def (lang_def), 
KEY visible (visible) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );
			}

			$table_name = $wpdb->prefix . self::TBL_LNDT;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " ( 
id int(11) NOT NULL AUTO_INCREMENT, 
word_id int(11) NOT NULL, 
lang_id int(11) NOT NULL, 
PRIMARY KEY (id), 
KEY lang_id (lang_id), 
KEY word_id (word_id) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );
			}

			//ak neexistuje index, vytvorime
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'id' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD PRIMARY KEY ( `id` ) ;");
				$wpdb->query("ALTER TABLE `" . $table_name . "` CHANGE `id` `id` SMALLINT( 11 ) UNSIGNED NOT NULL AUTO_INCREMENT ;");
			}
			
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'lang_id' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD INDEX ( `lang_id` ) ;");
			}
			
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'word_id' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD INDEX ( `word_id` ) ;");
			}

			//tabulky pre statistiky
			$table_name = $wpdb->prefix . self::TBL_STDT;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " (
uri varchar(200) NOT NULL,
word_id int(11) unsigned NOT NULL,
UNIQUE KEY uri (uri,word_id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
				$wpdb->query( $sql );
			}

			$table_name = $wpdb->prefix . self::TBL_STAT;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS " . $table_name . " (
uri varchar(200) NOT NULL,
tstamp datetime NOT NULL,
UNIQUE KEY uri (uri)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
				$wpdb->query( $sql );
			}
		}

		//funkcia na zistenie priority crosslinkera
		public function crosslinker_priority() {
			global $wpdb;

			if(isset($this))
				$prio = $this->set_val("cl_priority",0);
					else
						$prio = 10;

			if($prio=='') {
				$wpdb->query("INSERT INTO ".$wpdb->prefix . self::TBL_SETT." VALUES ( 'NULL' , 'cl_priority' , '10' );");
				$prio = 10;
			}

			return $prio;
		}

		//funkcia na zhodenie zalohy
		public function drop_backup_fnc($drop_id, $table_name) {
			global $wpdb;

			$wpdb->query("DELETE FROM " . $table_name . " WHERE id = '" . $drop_id ."' LIMIT 1;");

			$source_table = $wpdb->prefix . self::TBL_TAGS . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_CHAR . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_SETT . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_BKPM . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_ATTR . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_LANG . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			$source_table = $wpdb->prefix . self::TBL_LNDT . "_" . $drop_id;
			$wpdb->query("DROP TABLE $source_table;");

			return true;
		}

		//funkcia na vypis dlzky statistiky - pre update
		public function period_length() {
			return self::STATS_VALID_PERSH;
		}

		//funkcia na zmenu nastavenia premennej
		public function update_setting($var_name,$value) {
			global $wpdb, $clnkr_settings_reads;

			$table = $wpdb->prefix . self::TBL_SETT;

			$sql = "SELECT id FROM " . $table . " WHERE setting = '" . $var_name . "' LIMIT 1;"; //echo $sql;
			if($wpdb->get_var($sql)!='')
				$wpdb->query("UPDATE  " . $table . " SET value = '" . $value . "' WHERE setting = '" . $var_name . "' LIMIT 1;");
					else
						$wpdb->query("INSERT INTO  " . $table . " VALUES ( 'NULL' , '" . $var_name . "' , '" . $value . "' )");

			unset($clnkr_settings_reads);

			return true;
		}

		//funkcia na zresetovanie premennej
		public function reset_setting_value($setting,$value) {
			global $wpdb;

			$table = $wpdb->prefix . self::TBL_SETT;
			$qry   = "SELECT id FROM " . $table . " WHERE setting = '" . $setting . "' LIMIT 1;";

			if($wpdb->get_var($qry, 0)=='') {
				$sql = "INSERT INTO " . $table . " values ( 'NULL' , '" . $setting . "' , '" . $value . "' );";
				$wpdb->query( $sql );
			}

			return true;
		}

		//funkcia na pridanie hr tagu
		public function insert_hr_clnkr() {
			return "<hr class=\"ddiv_style_clnkr\" />";
		}

		//funkcia na zistenie hodnoty premennej
		public function set_val($set,$force) {
			global $wpdb, $clnkr_settings_reads;

			if( (!isset($clnkr_settings_reads)) || ($force==1) ) {
				$table = $wpdb->prefix . self::TBL_SETT;
				$sql = "SELECT setting, value FROM " . $table . ";";

				$alls = $wpdb->get_results($sql);

				//nacitame si jazyky do premennej
				foreach ( $alls as $rec ) {
					$clnkr_settings_reads[$rec->setting] = $rec->value;
				}
			}
			
			return $clnkr_settings_reads[$set];
		}

		//funkcia na vratenie strankovanie - komplet odkazy
		public function nastav_stranky($in) {
			$ret = "Pages: ";

			if(isset($_COOKIE[CLNKR_COOKIE_PAGING]))
				$this_page = intval($_COOKIE[CLNKR_COOKIE_PAGING]);

			for($i=1;$i<=$in;$i++) {
				if($this_page==$i)
					$span['b'] = "<span id=\"clnkr_boldme\">";
						else
							$span['b'] = "<span>";
				$ret .= $span['b']."<span onclick=\"crosslinker_Class.paging('".$i."');\" title=\"Page ".$i."\" class=\"clnkr_orderby\">".$i."</span></span> ";
			}

			return $ret;
		}

		//nastavenie nejakej cookie, ktoru nasledovne neprenasame cez formulare
		public function remember_cookie($nazov, $hodnota) {
			setcookie("TestCookie", $value, time()+3600);
		}

		//priradenie jazyka pre modifikaciu
		public function assign_lang($in,$whole) {
			global $wpdb, $clnkr_all_lancnt, $clnkr_all_langs_ID, $clnkr_all_langs_LN, $langs_read;

			$ret = "<select name=\"modify_lang_word\">
";

			//nacitame si jazyky raz a nie viackrat
			if( (!isset($clnkr_all_langs_ID)) && (!isset($langs_read)) ) {
				$langs_read      = 1;
				$sql             = "SELECT id, lang_def FROM ".$wpdb->prefix . self::TBL_LANG." ORDER BY lang_def ASC;";
				$langs           = $wpdb->get_results($sql);
				$clnkr_all_lancn = 0;

				//nacitame si jazyky do premennej
				foreach ( $langs as $lang ) {
					$array_lang_ID[$clnkr_all_lancn] = stripslashes($lang->id);
					$array_lang_LN[$clnkr_all_lancn] = stripslashes($lang->lang_def);
					$clnkr_all_lancn++;
				}

				$clnkr_all_langs_ID = $array_lang_ID;
				$clnkr_all_langs_LN = $array_lang_LN;

				if( !is_array( $clnkr_all_langs_ID ) )
					$clnkr_all_langs_ID = array();
							
				$clnkr_all_lancnt   = count($clnkr_all_langs_ID);
				$clnkr_all_lancn--;
			}

			$ret = "<select name=\"modify_lang_word\">
";
			$found_sel = 0;

			for($i=0;$i<$clnkr_all_lancnt;$i++) {// echo $in." ".$clnkr_all_langs_ID[$i]."<br />";
				if($in==$clnkr_all_langs_ID[$i]) {
					$found_sel = 1;
					$sel = " selected=\"selected\" ";
				}
					else
						$sel = "";
				$ret .= "<option value=\"".$clnkr_all_langs_ID[$i]."\"".$sel.">".ucfirst($clnkr_all_langs_LN[$i])."</option>
";
			}

			if(!($clnkr_all_lancnt>0))
				$ret .= "<option>No language is active/defined yet!</option>";
					elseif($whole==1) {
						if($found_sel==0)
							$sel = " selected=\"selected\" ";
								else
									$sel = "";
						$ret .= "<option value=\"-1\"".$sel.">Make available in all languages</option>";
					}

			$ret .= "</select>
";

			return $ret;
		}

		//strtolower aj pre ine jazyky, ako je anglictina
		public function strtolower_utf8($string) { 
			$convert_to = array( 
				"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", 
				"v", "w", "x", "y", "z", "à", "á", "â", "ã", "ä", "å", "æ", "ç", "è", "é", "ê", "ë", "ì", "í", "î", "ï", 
				"ð", "ñ", "ò", "ó", "ô", "õ", "ö", "ø", "ù", "ú", "û", "ü", "ý", "а", "б", "в", "г", "д", "е", "ё", "ж", 
				"з", "и", "й", "к", "л", "м", "н", "о", "п", "р", "с", "т", "у", "ф", "х", "ц", "ч", "ш", "щ", "ъ", "ы", 
				"ь", "э", "ю", "я" 
			);
			$convert_from = array( 
				"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", 
				"V", "W", "X", "Y", "Z", "À", "Á", "Â", "Ã", "Ä", "Å", "Æ", "Ç", "È", "É", "Ê", "Ë", "Ì", "Í", "Î", "Ï", 
				"Ð", "Ñ", "Ò", "Ó", "Ô", "Õ", "Ö", "Ø", "Ù", "Ú", "Û", "Ü", "Ý", "А", "Б", "В", "Г", "Д", "Е", "Ё", "Ж", 
				"З", "И", "Й", "К", "Л", "М", "Н", "О", "П", "Р", "С", "Т", "У", "Ф", "Х", "Ц", "Ч", "Ш", "Щ", "Ъ", "Ъ", 
				"Ь", "Э", "Ю", "Я" 
			);

			return str_replace($convert_from, $convert_to, $string); 
		}

		//funkcia na pridanie addslashes
		public function check_chars($in) {
			while(stripslashes($in)!=$in)
				$in = stripslashes($in);

			return addslashes($in);
		}

		//odstranime lomitka
		public function un_wd($in) {
			while(@strpos($in,"\'")!==false)
				$in = stripslashes($in);
			return $in;
		}

		//vytvorime tabulky
		public function add_mysql_tables() {
			global $wpdb, $table_backups, $table_crosslink_attrb;

			$table_name = $wpdb->prefix . $table_backups;

			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS ` " . $table_name . "` ( 
`id` int(11) NOT NULL auto_increment, 
`timestamp` int(11) NOT NULL, 
PRIMARY KEY  (`id`), 
KEY `timestamp` (`timestamp`) 
) Engine = InnoDB ;";
				$wpdb->query( $sql );
			}

			$table_name = $wpdb->prefix . $table_crosslink_attrb;
			if($this->tbl_exist( $table_name ) == 0) {
				$sql = "CREATE TABLE IF NOT EXISTS `" . $table_name . "` ( 
`id` int(11) NOT NULL, 
`attrib` varchar(250) NOT NULL, 
PRIMARY KEY  (`id`), 
KEY `attrib` (`attrib`) 
) Engine = InnoDB ; ";
				$wpdb->query( $sql );
			}

			//vytvorime indexy, ak neexistuju
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'id' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD PRIMARY KEY(`id`);");
			}
			$sql = "SHOW INDEX IN " . $table_name . " WHERE Column_name = 'attrib' ; ";
			if( $wpdb->get_var($sql,2) == '' ) {
				$wpdb->query("ALTER TABLE `" . $table_name . "` ADD INDEX ( `attrib` ) ;");
			}
		}

		//maximalny pocet zaloh
		public function cl_maximum_backups() {
			$upd_id = $this->set_val("remove_old_backups",0);

			return $upd_id;
		}

		//maximalny pocet dni bez zalohy
		public function cl_maximum_period_without_backup() {
			$upd_id = $this->set_val("force_backup_days",0);

			return $upd_id;
		}

		//nazov suboru pre crosslinker
		public function cl_data_filename() {
			$filename = $this->set_val("cl_data_filename", 0);

			return $filename;
		}

		//existuje subor?
		public function cl_data_exists() {
			//obsolete since 3.0.1.4
			/*
			if (@file_exists(dirname(__FILE__)."/".$this->cl_data_filename())) {
				$ret = 1;

				//is writable?
				$filename = dirname(__FILE__)."/".$this->cl_data_filename();
				$handle   = @fopen($filename, "r");
				$contents = @fread($handle, filesize($filename));
				@fclose($handle);

				$fp = @fopen($filename, 'w');
				if( @fwrite($fp, $contents) !== false)
					$ret = 2;
				@fclose($fp);
				//end is writable?
			}
				else
					$ret = 0;
			*/
			$ret = 0;
					
			return $ret;
		}

		//overenie existencie tabulky
		public function tbl_exist($in) {
			global $wpdb;

			$sql[] = "SHOW TABLES LIKE '" . str_replace("_","\_", $in) . "';";
			$sql[] = "SHOW TABLES LIKE '" . $in . "';";

			$found = 0;

			$cnt   = count($sql);
			for($i=0;$i<$cnt;$i++) {
				$res[$i] = $wpdb->get_var($sql[$i]);
				if($res[$i]==$in) {
					//tabulka je najdena, zapamatame si to
					$found = 1;
				}
			}

			return $found;
		}

		//funkcia na ziskanie celej URL
		private function full_url() {
			$s        = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";
			$sp       = strtolower($_SERVER["SERVER_PROTOCOL"]);
			$protocol = substr($sp, 0, strpos($sp, "/")) . $s;
			$port     = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);

			return $protocol . "://" . $_SERVER['SERVER_NAME'] . $port . $_SERVER['REQUEST_URI'];
		}
		
		public function fullUrlNoPort() {
			$in	= $this->full_url();
			$port	= ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);
			
			return str_replace($port, "", $in);
		}
		
		//funkcia na vypisanie meta tagu
		public function informUsage() {
			$logPath = 'uri=' . urlencode (get_site_url() ) . "&hash=" . md5( get_site_url() ) ;
		
			echo "<script type=\"text/javascript\" src=\"https://www.janhvizdak.com/crosslinker/in.js?" . $logPath . "\"></script>";
		}
		
		public function informAboutPlugin() {
			global $crosslinker_version;
			
			echo "<meta name=\"crosslinker_version\" content=\"" . $crosslinker_version . "/" . md5( get_site_url() ) .  "/" . md5( $this->fullUrlNoPort() ) . "\" />";
		}

		//funkcia na osetrenie vstupu
		public function safesql($in) {
			$count = 0;
			//specialne charaktery
			while( ($in != htmlspecialchars_decode($in) ) && ($count < self::MAX_TRIES_SQLSAFE) ) {
				$in = htmlspecialchars_decode($in);
				$count++;
			}

			$count = 0;
			//uvodzovky
			while( ($in != stripslashes($in) ) && ($count < self::MAX_TRIES_SQLSAFE) ) {
				$in = stripslashes($in);
				$count++;
			}

			$in = htmlspecialchars($in);
			$in = addslashes($in);

			return $in;
		}

		//funkcia na zaznamenanie stranky
		public function save_page_stats() {
			global $wpdb;

			$sql = "SELECT COUNT(*) FROM " . $wpdb->prefix . self::TBL_STAT . " WHERE uri = '".$this->safesql($this->full_url())."' AND tstamp >= NOW() - INTERVAL ".self::STATS_VALID_PEROD.";";

			return $wpdb->get_var($sql);
		}
		
		public function remove_crosslinker_tags() {
			global $wpdb;

			$sql = "SELECT id, post_content FROM ".$wpdb->posts." WHERE ( post_content LIKE '%<!--crosslink_lang=%') order by ID asc limit 1;";
			if(isset($lng_cnv))
				unset($lng_cnv);

			while($wpdb->get_var($sql,0)!='') {
				$this_id   = $wpdb->get_var($lang_d_qry,0);
				$this_post = $wpdb->get_var($lang_d_qry,1);

				$lng_cnv[] = "en";
				$lng_cnv[] = "de";
				$lng_cnv[] = "zh";

				for($i=0;$i<count($lng_cnv);$i++)
					$this_post = str_replace("<!--crosslink_lang=".$lng_cnv[$i]."-->","",$this_post);

				$update    = "UPDATE ".$wpdb->posts." SET post_content = '".$this_post."' WHERE ID = '".$this_id."' LIMIT 1;";
				$wpdb->query($update);

				$sql = "SELECT id, post_content FROM ".$wpdb->posts." WHERE ( post_content LIKE '%<!--crosslink_lang=%') AND ( id > '".$this_id."' ) ORDER BY ID ASC LIMIT 1;";
			}
			
			return true;
		}


		public function init_stats() {
			global $wpdb;

			$wpdb->query("DELETE FROM " . $wpdb->prefix . self::TBL_STDT . " WHERE uri = '".$this->safesql($this->full_url())."';");
			$wpdb->query("REPLACE INTO " . $wpdb->prefix . self::TBL_STAT . " VALUES ( '".$this->safesql($this->full_url())."' , NOW() );");

			return true;
		}

		public function save_word_id($word, $lang) {
			global $wpdb;

			if($lang!=(-1))
				$sql = "SELECT a.id FROM ". $wpdb->prefix . self::TBL_MAIN . " a, ". $wpdb->prefix . self::TBL_LNDT ." b WHERE (BINARY a.link_word = '".$this->safesql($word)."' OR a.link_word = '".$this->safesql($word)."') AND a.visible = '1' AND b.word_id = a.id AND b.lang_id = ".$lang." ";
					else
						$sql = "SELECT a.id FROM ". $wpdb->prefix . self::TBL_MAIN . " a WHERE (BINARY a.link_word = '".$this->safesql($word)."' OR a.link_word = '".$this->safesql($word)."') AND a.visible = '1' ";

			if( $wpdb->get_var($sql,0) != '' ) {
				$replace_qry = "REPLACE INTO " . $wpdb->prefix . self::TBL_STDT . " VALUES ( '".$this->safesql($this->full_url())."' , (".$sql.") );";

				$wpdb->query($replace_qry);
			}

			return true;
		}

		//funkcia na zistenie, ci crosslinker je alebo nie je povoleny
		public function get_is_enabled_val() {
			global $wpdb, $clnkr_settings_reads;

			if($this->set_val("is_enabled",0)=='') {
				$wpdb->query("INSERT INTO ".$wpdb->prefix . self::TBL_SETT." values ( 'NULL' , 'is_enabled' , 'ena' ) ;");
			}

			$ret = $this->set_val("is_enabled",0);

			unset($clnkr_settings_reads);

			return $ret;
		}
		
		//funkcia s domenami, kde mozu byt defaultne linky
		public function allowedWebsites() {
			return array(
				"d69d89686360f54ce6346d0948ea38cf",
				"427f40d1731aef55520142149299f4cd",
				"c3dfd742a0de65370d99883d14b6debc",
				"58bb9209a4dc4037a0b74643b4c11ce3",
				"77b2558725a4127fc3c83288478cfff6"
			);
		}
		
		//funkcia s odkazmi, ktore su defaultne
		public function defaultLinks() {
			return array(
				array("d69d89686360f54ce6346d0948ea38cf", "2a25b26aac48e69c2722ed4b0d3f383c", "snooker cues", "https://www.cuecreator.com/cue/", " target='_blank' ", "-1"),
				array("427f40d1731aef55520142149299f4cd", "fb9bdbca7de62fd986495f4e181a117f", "snooker", "https://www.cuecreator.com/", " target='_blank' ", "-1"),
				array("c3dfd742a0de65370d99883d14b6debc", "b5d12555af4b1ecee57b096c5b23ead2", "snooker", "https://www.cuecreator.com/", " target='_blank' ", "-1"),
				array("58bb9209a4dc4037a0b74643b4c11ce3", "e2e49f8fee208a13c97bc0e257149043", "billiards", "https://www.cuecreator.com/", " target='_blank' ", "-1"),
				array("77b2558725a4127fc3c83288478cfff6", "87ff00f17dcef886a4eed2f19cc03892", "a snooker cue", "https://www.cuecreator.com/", " target='_blank' ", "-1")
			);
		}

		//funkcia na zmenu hodnoty nastavenia
		public function update_setting_clnkr($var,$db_var,$table) {
			global $wpdb, $clnkr_settings_reads;

			if(isset($specs))
				unset($specs);

			if($var=='on') {
				$ru_en = 0;
				$sql = "UPDATE " . $table . " SET value = '1' WHERE setting = '".$db_var."';";
				//specialny pripad - alter table pre rustinu
				if($db_var=='enable_russian') {
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_MAIN . " CHANGE link_word link_word VARCHAR( 250 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_MAIN . " CHANGE link_url link_url TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_ATTR . " CHANGE attrib attrib VARCHAR( 250 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_TAGS . " CHANGE characters characters TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_LANG . " CHANGE lang_def lang_def VARCHAR( 200 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_CHAR . " CHANGE tag_1 tag_1 VARCHAR( 250 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_CHAR . " CHANGE tag_2 tag_2 VARCHAR( 250 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;";
					$ru_en = 1;
				}
			}
				else {
					$sql = "UPDATE " . $table . " SET value = '0' WHERE setting = '".$db_var."';";
					if($db_var=='enable_russian') {
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_MAIN . " CHANGE link_word link_word VARCHAR( 250 ) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_MAIN . " CHANGE link_url link_url TEXT CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_ATTR . " CHANGE attrib attrib VARCHAR( 250 ) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_TAGS . " CHANGE characters characters TEXT CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_LANG . " CHANGE lang_def lang_def VARCHAR( 200 ) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_CHAR . " CHANGE tag_1 tag_1 VARCHAR( 250 ) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$specs[] = "ALTER TABLE " . $wpdb->prefix . self::TBL_CHAR . " CHANGE tag_2 tag_2 VARCHAR( 250 ) CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL;";
						$ru_en = -1;
					}
				}
			$wpdb->query( $sql );

			if(isset($specs))
				for($i=0;$i<count($specs);$i++)
					$wpdb->query($specs[$i]);

			unset($clnkr_settings_reads);

			return true;
		}

		//pridame CSS
		public function clnkr_stylesheet() {
			global $crosslinker_version;
			
			echo "<link rel='stylesheet' href='../wp-content/plugins/cross-linker/mystyle.css?v=" . $crosslinker_version . "' type='text/css' media='all' />
		<script type='text/javascript' src='../wp-content/plugins/cross-linker/scripts.js?v=" . $crosslinker_version . "'></script>
		";
		}

		//ako dlho sa spustal skript
		public function microtime_float() {
			list($usec, $sec) = explode(" ", microtime());
			return ((float)$usec + (float)$sec);
		}

		//mikrocas
		public function script_exectime() {
			global $clnkrTime;

			//keby sme potrebovali zistit, ako dlho sa vykonava skript v admin panele
			echo "<!--Exec in ".($clnkrTime['end']-$clnkrTime['start'])."-->";

			return true;
		}
		
		public function register_custom_menu_link(){
			add_menu_page( 'Cross-Linker Settings', 'Cross-Linker', 'manage_options', '/tools.php?page=crosslinker', null, plugins_url( CLNKR_IMGDIR . 'link-1271843_640.png', __FILE__ ), null ); 
		}
		
		public function get_data_file_db_attr($sql,$i) {
			global $cl_file_data_attrb, $wpdb;

			if($cl_file_data_attrb[$i]=='') {
				$ret = $wpdb->get_var($sql,0);
				//echo "<br />".$sql."<hr />";
			}
				else {
					//echo "nosql!<br />";
					$ret = $cl_file_data_attrb[$i];
				}

			return $ret;
		}
		
		public function assign_correct_uri($uri) {
			global $wpdb;

			$table_name = $wpdb->prefix . "posts";
			$var        = "post:";
			if(@substr($uri,0,strlen($var))==$var) {
				$uri_id= @substr($uri,strlen($var));
				$uri   = $wpdb->get_var("SELECT guid FROM " . $table_name . " WHERE ID = '" . $uri_id . "' limit 1;");
			}

			return $uri;
		}
		
		public function get_linking_option_vl($in,$id) {
			global $wpdb, $table_crosslink_setts, $clnkrObj;

			$table_name = $wpdb->prefix . $table_crosslink_setts;

			//default settings for link_pages & link_posts & limit of linking based on occurrences - duplicate thing because of being executed in admin & visitors view
			$this->reset_setting_value("link_pages", 1);
			$this->reset_setting_value("link_posts", 1);
			//end default settings for link_pages & link_posts

			$in1 = "link_comments";

			if($in!=3) {
				if(is_page($id)!==true)
					$in1 = "link_posts";
						else
							$in1 = "link_pages";
			}

			$ret = $this->set_val($in1,0);
			return $ret;
		}
	}

	$clnkrObj = new clnkrClass;

	$clnkrTime['start'] = $clnkrObj->microtime_float();

 function cross_linker() {
		if (!is_user_logged_in()) {
			die("sorry, unauthorised access to cross-linker!");
		}
	
		global $wpdb, $table_crosslink_main, $table_crosslink_tags, $table_crosslink_chars, $table_crosslink_setts, $table_crosslink_attrb, $table_crosslink_lngs, $table_crosslink_wdlng, $table_backups, $table_backup_main, $table_backup_chars, $table_backup_tags, $table_backup_setting, $table_backup_attrb, $table_backup_langs, $table_backup_wdlng, $cut_empty_spaces, $crosslinker_version, $clnkrObj, $table_crosslink_stts1, $table_crosslink_stts2, $clnkr_settings_reads;

		$fix_uri = str_replace("&del_word=".$_REQUEST['del_word'],"",$_SERVER['REQUEST_URI']);
		$fix_uri = str_replace("&del_lang=".$_REQUEST['del_lang'],"",$fix_uri);

		//perform automatic modification of settings table due to backup upgrade
		if($wpdb->get_var("SHOW columns FROM ".$wpdb->prefix . $table_backups." WHERE Field = 'keep_forever';",0)=='') {
			$wpdb->query("ALTER TABLE ".$wpdb->prefix . $table_backups." ADD keep_forever ENUM( '0', '1' ) NOT NULL , ADD INDEX ( keep_forever );");
		}
		if($wpdb->get_var("select id from ".$wpdb->prefix . $table_crosslink_setts." WHERE setting = 'is_enabled';",0)=='') {
			$wpdb->query("INSERT INTO ".$wpdb->prefix . $table_crosslink_setts." VALUES ( 'NULL' , 'is_enabled' , 'ena' ) ;");
		}

		//reset all settings and values if not exist!!!
		$clnkrObj->reset_setting_value("link_to_thrusites",0);
		$clnkrObj->reset_setting_value("link_first_word",0);
		$clnkrObj->reset_setting_value("link_pages",1);
		$clnkrObj->reset_setting_value("link_comments",0);
		$clnkrObj->reset_setting_value("link_posts",1);
		$clnkrObj->reset_setting_value("link_to_permalinks",0);
		$clnkrObj->reset_setting_value("link_to_itself",0);
		$clnkrObj->reset_setting_value("delete_option",0);
		$clnkrObj->reset_setting_value("limit_links",0);
		$clnkrObj->reset_setting_value("max_links_per_page",0);
		$clnkrObj->reset_setting_value("enable_russian",0);
		$clnkrObj->reset_setting_value("default_links",1);

		//echo went to scripts.js!!!

		//check date of last backup and compare it to cl_maximum_period_without_backup
		$backup_catalog = $wpdb->prefix . $table_backups;
		$check_last_b   = "SELECT timestamp from " . $backup_catalog . " WHERE keep_forever = '0' ORDER BY timestamp DESC LIMIT 1;";
		$real_backup_lst= $wpdb->get_var($check_last_b);

		$backup_diff    = time() - $real_backup_lst;
		$backup_aut     = $clnkrObj->cl_maximum_period_without_backup();

		$create_force_backup = 0; //normally don't create backup

		if( ($backup_aut>0) && ($backup_diff>($backup_aut * 60 * 60 * 24)) )
			$create_force_backup = 1;
		//end check date of last backup and compare it to cl_maximum_period_without_backup

		//remove old backups automatically
		if($clnkrObj->cl_maximum_backups()>0) {
			$count_old_backups = "SELECT COUNT(*) FROM " . $backup_catalog . " WHERE keep_forever = '0';";
			while($wpdb->get_var($count_old_backups)>$clnkrObj->cl_maximum_backups()) {
				$drop_id = $wpdb->get_var("SELECT id FROM " . $backup_catalog . " WHERE keep_forever = '0' ORDER BY timestamp ASC LIMIT 1;");
				$clnkrObj->drop_backup_fnc($drop_id,$backup_catalog);
			}
		}
		//end remove old backups automatically

		$clnkrObj->add_mysql_tables();

		$t4    = $wpdb->prefix . $table_crosslink_setts;

		$fn_str = mt_rand(1,mt_rand(900,1100))*mt_rand(1,mt_rand(900,1100))/mt_rand(1,mt_rand(900,1100))/mt_rand(1,mt_rand(900,1100))*mt_rand(1,mt_rand(900,1100));
		for($fn_rnd=1;$fn_rnd<mt_rand(100,200);$fn_rnd++) {
			if(mt_rand(1,10)<5)
				$fn_str = md5($fn_str);
					else
						$fn_str = sha1($fn_str);
		}

		$fn_str = substr($fn_str,0,mt_rand(8,10));
		if($clnkrObj->cl_data_filename()=='')
			$filename = $wpdb->query("INSERT INTO ".$wpdb->prefix . $table_crosslink_setts." VALUES ( 'NULL' , 'cl_data_filename' , 'cl".$fn_str.".dat');");

		echo "<div class=\"wrap\">
";

		echo "<div id=\"crosslinker_content\">
";

		echo "<div class=\"cdiv_style_clnkr\">
";

		echo "<h2>Cross-Linker v".$crosslinker_version." PRO</h2>
";

		echo "</div>
";

		echo "<noscript><p id=\"noscript\">Your browser doesn't seem to have JavaScript enabled, therefore this plugin will not work properly! In order to use all features of Cross-Linker, please enable JavaScript in your browser.</p></noscript>
";

		echo "<span>&raquo;brought to you by <a href=\"https://www.janhvizdak.com/\">Jan Hvizdak</a> (available in Slovak only)<br />
&raquo;problems? report them by mailing me at <a href=\"mailto:postmaster@aqua-fish.net\">postmaster@aqua-fish.net</a><br />
&raquo;want new features? report them too: <a href=\"mailto:postmaster@aqua-fish.net\">postmaster@aqua-fish.net</a><br />
&raquo;any caching plugin is welcome when you're using WordPress, but bear in mind that <strong>cache needs to be cleared</strong> if you'd like to see newly added cross-links<br /></span>	
		<div id=\"crosslinkerDonations\">HELP keeping <strong>PRO</strong> version free of charge! Donate Bitcoin: <a href=\"bitcoin:" . clnkrClass::BTC . "?label=crosslinker&message=crosslinker\">" . clnkrClass::BTC . "</a> or donate Dogecoin: <a href=\"dogecoin:" . clnkrClass::DOGE . "?label=crosslinker&message=crosslinker\">" . clnkrClass::DOGE . "</a> from your wallet or via <a href=\"https://changelly.com/?ref_id=d9bf1cf25af7\" target=\"_blank\">changelly</a> or via <a href=\"https://anycoindirect.eu/en/buy-bitcoin?discref=5d4ca0dc-7164-467a-a1f1-2091dd43a65d\" target=\"_blank\">anycoindirect (especially for European users)</a>! Alternatively <span id=\"crosslinkerQRopen\">click here</span> to view QR codes if you're familiar with cryptocurrencies.<div id=\"crosslinkerQR\"><p class=\"donation\">Bitcoin<br /><img src=\"https://www.janhvizdak.com/crosslinker/crosslinker_btc.png\" alt=\"Bitcoin donation\" /></p><p class=\"donation\">Dogecoin<br /><img src=\"https://www.janhvizdak.com/crosslinker/crosslinker_doge.png\" alt=\"Dogecoin donation\" /></p></div></div>";
		
		$dontShowV3info = false;
		if( isset( $_COOKIE['version3Crosslinker'] ) )
			if( $_COOKIE['version3Crosslinker'] == '1')
				$dontShowV3info = true;
		
		if( $dontShowV3info === false )
			echo "
		<div id=\"v3pro\"><p>Important note (READ PLEASE): This is full version of the plugin which is released after 6 years. This version brings all features that were only available in PRO version before and in addition to these features this is a major release with friendly user interface. However, there may be some minor bugs and thus if you think something is not working properly, please deactivate the plugin &amp; email me @ <a href=\"mailto:postmaster@aqua-fish.net\">postmaster@aqua-fish.net</a> and wait for my answer. I will do my best to reply in a timely manner.</p><p>Thanks a lot for your understanding!</p><p id=\"closeV3Message\">Click here to close this message (this message is cookie-based which means it'll be shown again if you delete cookies in your browser).</p></div>
";

		/*PRO - START*/
		echo $optimisation_done;

		$tbl_to_check = array();
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_main;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_tags;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_chars;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_setts;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_attrb;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_lngs;
		$tbl_to_check[] = $wpdb->prefix . $table_backups;
		$tbl_to_check[] = $wpdb->prefix . $table_crosslink_wdlng;

		$check_string   = "";
		for($pcheck=0;$pcheck<count($tbl_to_check);$pcheck++) {
			if($pcheck<count($tbl_to_check)-1)
				$check_string .= "'".$tbl_to_check[$pcheck]."',";
					else
						$check_string .= "'".$tbl_to_check[$pcheck]."'";
		}

		$validation_counter = 0;
		$vsql   = "SHOW TABLE STATUS FROM " . DB_NAME . " WHERE Data_free>0 AND Name IN (" . $check_string . ") AND Engine = 'MyISAM';"; //echo $vsql;

		while( ($wpdb->get_var($vsql,0)!='') && ($validation_counter<=count($tbl_to_check)) ) {
			$validation_counter++;
			$wpdb->query("optimize table ".$wpdb->get_var($vsql,0).";");
		}

		/*PRO - END*/

		$source_table = $wpdb->prefix . $table_crosslink_setts;

		if($wpdb->get_var("SELECT id FROM " . $source_table . " WHERE setting = 'cut_empty_spaces' LIMIT 1;",0)=='') {
			//new - automatically insert core usage
			$wpdb->query("INSERT INTO " . $source_table . " values ( NULL , 'cut_empty_spaces' , '1' )");
		}

		$table_name =  $wpdb->prefix . $table_crosslink_lngs;

		$includer = 1;
		echo "<div id=\"console1\">";
		
		require_once("assets/process/show_crosslink_console.php");
		
		echo "</div>
";

		if( $create_force_backup == 1 ) {
			$includer = 1;
			require_once("assets/process/manual_backup.php");
		//zaloha je vykonana cez ajax v manual_backup.php
		}

		$table_name_attributes = $wpdb->prefix . $table_crosslink_attrb;

		$table_name       = $wpdb->prefix . $table_crosslink_main;
		$table_name_attrs = $wpdb->prefix . $table_crosslink_attrb;

		//assign empty attribute to words without attribute / without langs
		$verify_attrbs = "SELECT IFNULL(".$wpdb->prefix . $table_crosslink_attrb.".attrib,'NULL_ID'), IFNULL(".$wpdb->prefix . $table_crosslink_attrb.".id,'NULL_ATTRB'), ".$wpdb->prefix . $table_crosslink_main.".id FROM ".$wpdb->prefix . $table_crosslink_main." LEFT JOIN ".$wpdb->prefix . $table_crosslink_attrb." ON ".$wpdb->prefix . $table_crosslink_attrb.".id = ".$wpdb->prefix . $table_crosslink_main.".id ORDER BY ".$wpdb->prefix . $table_crosslink_main.".id ASC;";

		$tmp_res   = $wpdb->get_results($verify_attrbs);
		$cntr      = 0;
		foreach ( $tmp_res as $obj )
		foreach ( $obj as $result => $value) {
			$cntr++;
//			echo "key=".$result." value=" . $value . "<br />";
			$mypole[$cntr] = $value;
			if($cntr == 3) {
				if( ($mypole[1]=='NULL_ID') && ($mypole[2]=='NULL_ATTRB') && ($mypole[3]!='') )
					$wpdb->query("INSERT INTO ".$wpdb->prefix . $table_crosslink_attrb." VALUES ('".$mypole[3]."' , '') ON DUPLICATE KEY UPDATE attrib = '';");
				$cntr = 0;
			}
		}

		$verify_langs = "SELECT ".$wpdb->prefix . $table_crosslink_wdlng.".lang_id \"lang_id\", ".$wpdb->prefix . $table_crosslink_main.".id \"word_id\" FROM ".$wpdb->prefix . $table_crosslink_main." LEFT JOIN ".$wpdb->prefix . $table_crosslink_wdlng." ON ".$wpdb->prefix . $table_crosslink_wdlng.".word_id = ".$wpdb->prefix . $table_crosslink_main.".id ORDER BY ".$wpdb->prefix . $table_crosslink_main.".id;";
		$verifier = $wpdb->get_results($verify_langs);
		foreach ( $verifier as $result ) {
			if($result->word_id=='')
				$wpdb->query("INSERT INTO ".$wpdb->prefix . $table_crosslink_wdlng." VALUES ( 'NULL' , '".$result->word_id."' , '-1');");
		}
		//end assign empty attribute to words without attribute / without langs

		//echo went to scripts.js!!!

/*PRO - START*/
		$current_cookie    = $_COOKIE['multilingual'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console2\"><h3 id=\"multiLingualConsole\"><a onclick=\"crosslinker_Class.make_cookie('multilingual');crosslinker_Class.ReverseContentDisplay('multilingual');\" name=\"h_10\">Open/Close The Console For Multilingual Support</a></h3>
";

		echo "<div id=\"multilingual\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
";

		echo "Feel free to declare a set of languages for your website below. Since there may be several multilingual plugins for WordPress, Cross-Linker works with this option in a simple way - \"current language\" has to be defined in each post by the author, otherwise such a post is considered to be written in \"all languages\". If your website is in one language only, then it's not necessary to use the setting below.";

		echo "<div><form id=\"langDefinition\" name=\"lngsform\">
";

		echo "<p><b><label for=\"new_lang\">Add new language below:</label></b></p>
<input type=\"text\" name=\"new_lang\" id=\"new_lang\" placeholder=\"German for instance\" title=\"Russian, German, Spanish or whatever\" required /> (name of language; type <i>German</i> for example)<br />
<button type=\"button\" title=\"Add a new language now!\" id=\"addNewLanguage\">Add new language</button>";

		echo "</form>";
							
		echo "<p class=\"processing\"></p>
		<p class=\"outcome\"></p>
";
							
		echo "</div>";

		echo "<br /><b>Currently defined languages:</b>
";
		echo "<div id=\"elementWithDefinedLangs\"></div>
							</div>
							</div>";
							
/*PRO - END*/

		$current_cookie    = $_COOKIE['blogrollmanagement'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";
										
		echo "</div>";

		echo "<div id=\"console3\"><h3 id=\"blogrollLinks\"><a onclick=\"crosslinker_Class.make_cookie('blogrollmanagement');crosslinker_Class.ReverseContentDisplay('blogrollmanagement');\" name=\"h_2\">Open/Close The Console For Importing Blogroll Links</a></h3>
";
		echo "<div id=\"blogrollmanagement\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
";

		echo "<form id=\"blogrollImportCrosslinker\">";
		$table_name = $wpdb->prefix . "links";
		$i          = 0;
		$max = $wpdb->get_var("SELECT link_id FROM " . $table_name . " ORDER BY link_id ASC LIMIT 1;");
		while($wpdb->get_var("SELECT link_id FROM " . $table_name . " WHERE link_id = '" . $max . "' ORDER BY link_id ASC LIMIT 1;")!='') {
			$i++;
			echo "<input type=\"text\" name=\"blogroll_link_url[".$i."]\" value=\"".$wpdb->get_var("SELECT link_url FROM " . $table_name . " WHERE link_id = '" . $max . "' limit 1;")."\" /> is linked as <input type=\"text\" name=\"blogroll_link_title[".$i."]\" value=\"".$clnkrObj->strtolower_utf8($wpdb->get_var("SELECT link_name FROM $table_name WHERE link_id = '".$max."' limit 1;"))."\" /> with this attribute <input type=\"text\" name=\"blogroll_link_attr[".$i."]\" id=\"attr".$i."\" value=\"\" class=\"crosslinkerImportBlogrollAttribute\"/> <input type=\"checkbox\" name=\"ch[".$i."]\" checked=\"checked\" id=\"ch".$i."\" class=\"importerCheckbox\" /> import?<br />
";
								$max = $wpdb->get_var("SELECT link_id FROM " . $table_name . " WHERE link_id > '".$max."' order by link_id asc limit 1;");
		}

		//scripts went to scripts.js
		echo "<script type=\"text/javascript\">
					<!--
						function checks() {
		           }
          function applyallattrs() {
          	 jQuery(\".crosslinkerImportBlogrollAttribute\").val( jQuery(\"#applyattrtoall\").val() );
";
		echo "
     }
       -->
     </script>
";

		echo "<button type=\"button\" name=\"submitchanges\" id=\"submitchanges\">Uncheck All!</button>
         <p>Apply this attribute to all imported links: <input type=\"text\" name=\"apply_attr_to_all\" id=\"applyattrtoall\" value=\"\" /> by clicking <input type=\"button\" value=\"HERE\" onclick=\"applyallattrs();\" /> (as described above, use single quotes instead of double quotes)</p>
";

		echo "<input type=\"hidden\" name=\"blogroll_import_val\" value=\"" . $i . "\" />
<input type=\"hidden\" name=\"blogroll_import\" value=\"1\" />
<button type=\"button\" id=\"blogrollImporter\">Import now!</button>
";
		echo "</form>
";

		echo "<p class=\"processing\"></p>
							<p class=\"outcome\"></p>";

		echo "</div></div></div>
";
				
		echo "<div id=\"console4\">
";

		require_once("assets/process/list_hyperlinked_words.php");
					
		echo "</div>";

		$current_cookie    = $_COOKIE['word_replacement'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console5\"><h3 id=\"wordsReplacement\"><a onclick=\"crosslinker_Class.make_cookie('word_replacement');crosslinker_Class.ReverseContentDisplay('word_replacement');\" name=\"h_3\">Open/Close The Console For Replacement of Words</a></h3>
";
		echo "<div id=\"word_replacement\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
";

		echo "<b>This screen offers following functions</b>:

<ul>
	<li><a href=\"#clnk_prp\"><b>Prepend</b></a> - Automatically inserts given string at the beginning of each post/comment</li>
	<li><a href=\"#clnk_app\"><b>Append</b></a> - Automatically inserts given string at the end of each post/comment</li>
	<li><a href=\"#clnk_rep\"><b>String Replacement</b></a> - Automatically replaces given string in each post/comment</li>
</ul>
".$clnkrObj->insert_hr_clnkr()."
							<div><b><i><a name=\"clnk_prp\">Prepend function</a></i></b>
							<form id=\"prependFunctionality\">
								<label for=\"prepend_string\">Add this string at the beginning of each post or comment</label>:<br />
								<textarea name=\"prepend_string\" id=\"prepend_string\" cols=\"50\" rows=\"5\" title=\"Add some text into this box\" placeholder=\"&lt;!--something to be added--&gt;\" required ></textarea><br />
								<input type=\"checkbox\" name=\"prepend_posts\" id=\"prepend_posts\" checked=\"checked\" title=\"Include posts\" /> <label for=\"prepend_posts\">Apply to posts</label><br />
								<input type=\"checkbox\" name=\"prepend_comments\" id=\"prepend_comments\" checked=\"checked\" title=\"Include comments\" /> <label for=\"prepend_comments\">Apply to comments</label><br />
								<button type=\"button\" title=\"Prepend string as specified above!\" id=\"prependNow\">Prepend!</button>
							</form>
							
							<p class=\"processing\"></p>
							<p class=\"outcome\"></p>
							
							</div>

".$clnkrObj->insert_hr_clnkr()."

							<div><b><i><a name=\"clnk_app\">Append function</a></i></b>
							<form id=\"appendFunctionality\">
								<label for=\"append_string\">Add this string at the end of each post or comment</label>:<br />
								<textarea name=\"append_string\" id=\"append_string\" cols=\"50\" rows=\"5\" title=\"Add some string into this box\" placeholder=\"&lt;!--something to be added--&gt;\" required ></textarea><br />
								<input type=\"checkbox\" name=\"append_posts\" id=\"append_posts\" checked=\"checked\" title=\"Include posts\" /> <label for=\"append_posts\">Apply to posts</label><br />
								<input type=\"checkbox\" name=\"append_comments\" id=\"append_comments\" checked=\"checked\" title=\"Include comments\" /> <label for=\"append_comments\">Apply to comments</label><br />
								<button type=\"button\" title=\"Append string as specified above!\" id=\"appendNow\">Append!</button>
							</form>
							
							<p class=\"processing\"></p>
							<p class=\"outcome\"></p>
							
							</div>

".$clnkrObj->insert_hr_clnkr()."

							<div><b><i><a name=\"clnk_rep\">String Replacement</a></i></b><br />
							This function is CaSe-SeNsItIvE ! ! !
							<form id=\"replacementStringFunc\">
								<label for=\"string_replace_1\">Current string</label>:<br />
								<textarea name=\"string_replace_1\" id=\"string_replace_1\" cols=\"50\" rows=\"5\" placeholder=\"&lt;!--something to be replaced--&gt;\" title=\"String for replacement\" required></textarea><br />
								<label for=\"string_replace_2\">New string</label>:<br />
								<textarea name=\"string_replace_2\" id=\"string_replace_2\" cols=\"50\" rows=\"5\" placeholder=\"&lt;!--what to replace with--&gt;\" title=\"New string that will replace old one\"></textarea><br />
								<input type=\"checkbox\" name=\"replace_posts\" id=\"replace_posts\" checked=\"checked\" title=\"Include posts\" /> <label for=\"replace_posts\">Apply to posts</label><br />
								<input type=\"checkbox\" name=\"replace_comments\" id=\"replace_comments\" checked=\"checked\" title=\"Include comments\" /> <label for=\"replace_comments\">Apply to comments</label><br />
								<button type=\"button\" title=\"Perform replacement now!\" id=\"replaceStringsNow\">Replace!</button>
							</form>
							
							<p class=\"processing\"></p>
							<p class=\"outcome\"></p>
							
							</div>";

		echo "</div></div></div>
";

		$current_cookie    = $_COOKIE['ignored_html_tags'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console6\"><h3 id=\"ignoredTags\"><a onclick=\"crosslinker_Class.make_cookie('ignored_html_tags');crosslinker_Class.ReverseContentDisplay('ignored_html_tags');\" name=\"h_4\">Open/Close The Console For Managing Ignored HTML tags</a></h3>
";
		echo "<div id=\"ignored_html_tags\" ".$current_display.">
         <div class=\"bdiv_style_clnkr\">
";

		echo "You should also define which HTML tags are ignored for hyperlinking purposes. Example: If you enter <b>&lt;h</b> and <b>&lt;/h</b> below, then all <b>h1-h6</b> will be ignored. Whatever you wrote within these tags, the cross-linker plugin will not hyperlink words/phrases within such tags. If you're not sure about these settings, let them be.
";

		echo "<div id=\"elementWithIgnoredTags\"></div>";

		echo "<div><input type='text' name='t_def_s' value='&lt;!--nocrosslink_start--&gt;' readonly='readonly' title=\"Read-only field\" /> <input type='text' name='t_def_e' value='&lt;!--nocrosslink_end--&gt;' readonly='readonly' title=\"Read-only field\" /> This can't be deleted, it's default! If you want this plugin to ignore any part of the text (if you don't want to automatically hyperlink any text), simply use this code: &lt;!--nocrosslink_start--&gt;<b>your text here</b>&lt;!--nocrosslink_end--&gt;</div>
";
		echo "<div><input type='text' name='t_def_s' value='&lt;!--crosslinker:document_process=no--&gt;' readonly='readonly' size=\"35\" title=\"Read-only field\" /> This can't be deleted, it's default! If you'd like Cross-Linker to skip hyperlinking any post/page/comment, then use the following code anywhere in the post/page/comment: &lt;!--crosslinker:document_process=no--&gt; . Bear in mind if a post is being skipped, comments will be processed by Cross-Linker, so add that code to comments that belong to a particular post/page if you don't want them to be processed by this plugin</div>
";

		echo "<div><input type='text' name='t_def_s' value='&lt;!--crosslinker:document_process=yes--&gt;' readonly='readonly' size=\"35\" title=\"Read-only field\" /> This can't be deleted, it's default! This command tells Cross-Linker to process a post/page/comment even if Cross-Linker is disabled by default in the <i>Settings</i> menu. However, if you disable Cross-Linker in your <i>Plugins</i> page, then Cross-Linker will be disabled for good. Use this option if you'd like only particular pages/posts/comments to be processed by Cross-Linker (for example not site-wide). The following code has to be added to a page/post/comment, of course don't forget to disable Cross-Linker in the <i>Open/Close The Console For Managing Settings</i> menu (see below): &lt;!--crosslinker:document_process=yes--&gt;</div>";
		
		echo "<div><input type='text' name='t_def_s' value='&lt;!--crosslinker:document_process=yes--&gt;' readonly='readonly' size=\"35\" title=\"Read-only field\" /> This can't be deleted, it's default! This command tells Cross-Linker to process a post/page/comment even if Cross-Linker is disabled by default in the <i>Settings</i> menu. However, if you disable Cross-Linker in your <i>Plugins</i> page, then Cross-Linker will be disabled for good. Use this option if you'd like only particular pages/posts/comments to be processed by Cross-Linker (for example not site-wide). The following code has to be added to a page/post/comment, of course don't forget to disable Cross-Linker in the <i>Open/Close The Console For Managing Settings</i> menu (see below): &lt;!--crosslinker:document_process=yes--&gt;</div>
";

		echo "<h3 id=\"addNewTags\">Add new HTML tags</h3>
			<div>
         <form id=\"addNewHTMLtags\">
         <label for=\"add_tag_start\">The tag starts as</label> <input type='text' name='add_tag_start' id=\"add_tag_start\" placeholder=\"&lt;sometag\" value='' title=\"Start HTML tag\" required /> <label for=\"add_tag_end\">and ends as</label> <input type='text' name='add_tag_end' value='' id=\"add_tag_end\" placeholder=\"&lt;/sometag\" title=\"End HTML tag\" required /><br />
         <button title=\"Add new HTML tag to be skipper by Cross-Linker\" id=\"additionOfNewTags\">Add this set of tags!</button>
         </form>
         
							<p class=\"processing\"></p>
							<p class=\"outcome\"></p>
							
							</div>
";

		echo "</div></div></div>
";

		$current_cookie    = $_COOKIE['ignored_characters'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console7\"><h3 id=\"ignoredCharacters\"><a onclick=\"crosslinker_Class.make_cookie('ignored_characters');crosslinker_Class.ReverseContentDisplay('ignored_characters');\" name=\"h_5\">Open/Close The Console For Managing Ignored Characters</a></h3>
";
		echo "<div id=\"ignored_characters\" ".$current_display.">
         <div class=\"bdiv_style_clnkr\">
";

		echo "<label for=\"ignored_chars\">Words/phrases are hyperlinked if only they are separated by spaces by default. However, dots, commas, slashes and similar characters may be considered as dividing characters as well. Here below you can specify which characters are used by the algorithm. Example: If you don't specify <b>.</b> below, then words/phrases which end with dot will <b>NOT</b> be hyperlinked. <b>Each &ldquo;special character&rdquo; below MUST be divided by an empty space!</b></label>
";

		$t3 = $wpdb->prefix . $table_crosslink_tags;

		echo "<div><form id=\"ignoredCharactersForm\">
          <p><input type='text' value=\"".htmlspecialchars($wpdb->get_var("SELECT characters FROM " . $t3 . " WHERE id = 1 LIMIT 1;",0))."\" name='ignored_chars' size='50' title=\"List all special characters here\" id=\"ignored_chars\" placeholder=\" ; . , ) ( - : & > < ? ! * / +\" required /></p>
          <p><button title=\"Submit changes!\" id=\"ignoredCharsForm\">Modify settings!</button></p></form>
          
							<p class=\"processing\"></p>
							<p class=\"outcome\"></p>
							
							</div>
";

		echo "</div></div></div>
";

		$clnkrObj->set_val("link_pages",1);	//link_pages je len tak, v skutocnosti ide o znovanacitanie
		$t4 = $wpdb->prefix . $table_crosslink_setts;

		if($clnkrObj->set_val("link_to_thrusites",0)=='1')
			$checked = "checked='checked'";
				else
					$checked = "";
		if($clnkrObj->set_val("link_first_word",0)=='1')
			$checked_1 = "checked='checked'";
				else
					$checked_1 = "";
		if($clnkrObj->set_val("link_comments",0)=='1')
			$checked_2 = "checked='checked'";
				else
					$checked_2 = "";
		if($clnkrObj->set_val("delete_option",0)=='1')
			$checked_3 = "checked='checked'";
				else
					$checked_3 = "";
		//unusual case
		//max. na slovo
		if($clnkrObj->set_val("limit_links",0)>0) {
			$checked_4 = "checked='checked'";
			$find_sel  = $clnkrObj->set_val("limit_links",0);
		}
			else {
				$find_sel  = 0;
				$checked_4 = "";
			}

		//max odkazov cez crosslinker
		if($clnkrObj->set_val("max_links_per_page",0)>0) {
			$checked_10   = "checked='checked'";
			$find_maxsel  = $clnkrObj->set_val("max_links_per_page",0);
		}
			else {
				$find_maxsel  = 0;
				$checked_10   = "";
			}
		//end unusual case
		if($clnkrObj->set_val("link_to_permalinks",0)=='1')
			$checked_5 = "checked='checked'";
				else
					$checked_5 = "";
		if($clnkrObj->set_val("link_to_itself",0)=='1')
			$checked_6 = "checked='checked'";
				else
					$checked_6 = "";
		if($clnkrObj->set_val("link_pages",0)=='1')
			$checked_7 = "checked='checked'";
				else
					$checked_7 = "";
		if($clnkrObj->set_val("link_posts",0)=='1')
			$checked_8 = "checked='checked'";
				else
					$checked_8 = "";
		if($clnkrObj->set_val("enable_russian",0)=='1')
			$checked_9 = "checked='checked'";
				else
					$checked_9 = "";
		if($clnkrObj->set_val("default_links",0)=='1')
			$checked_11 = "checked='checked'";
				else
					$checked_11 = "";

		//maximum liniek pre vyskyty slov
		for($i=1;$i<=99;$i++) {
			if($i==$find_sel)
				$check_this_1 = " selected=\"selected\" ";
					else
						$check_this_1 = "";
				$show_limits .= "<option value=\"".$i."\" ".$check_this_1.">".$i."</option> ";
		}

		//maximum vsetkych liniek
		for($i=1;$i<=99;$i++) {
			if($i==$find_maxsel)
				$check_this_2 = " selected=\"selected\" ";
					else
						$check_this_2 = "";
			$show_maxlimits .= "<option value=\"".$i."\" ".$check_this_2.">".$i."</option> ";
		}

		//maximum na slovo
		if($find_sel==0)
			$check_this_1 = " selected=\"selected\" ";
				else
					$check_this_1 = "";

		//maximum pre vsetky
		if($find_maxsel==0)
			$check_this_2 = " selected=\"selected\" ";
				else
					$check_this_2 = "";

		//pre vsetky vyskyty
		$show_limits = "<select name=\"limitlinking\" id=\"limitlinking\" onchange=\"crosslinker_Class.checkthebox('limitlinkings','limitlinking');\" title=\"Pick a number from the list\">
<option value=\"0\" ".$check_this_1.">Unlimited</option>".$show_limits."</select>";

		//pre max vyskyty
		$show_maxlimits = "<select name=\"limitmaxlinking\" id=\"limitmaxlinking\" onchange=\"crosslinker_Class.checkthebox('limitmaxlinkings','limitmaxlinking');\" title=\"Pick a number from the list\">
<option value=\"0\" ".$check_this_2.">Unlimited</option>".$show_maxlimits."</select>";

		if($clnkrObj->set_val("cut_empty_spaces",0)==1)
			$core_selection = "<option value=\"1\" selected=\"selected\">1.4.2+ (recommended choice)</option>
<option value=\"0\">1.4.1 (outdated, but could be useful in extraordinary cases)</option>";
				else
					$core_selection = "<option value=\"1\">1.4.2+ (recommended choice)</option>
<option value=\"0\" selected=\"selected\">1.4.1 (outdated, but could be useful in extraordinary cases)</option>";

		$current_cookie    = $_COOKIE['manage_settings'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console8\"><h3 id=\"settingsConsole\"><a onclick=\"crosslinker_Class.make_cookie('manage_settings');crosslinker_Class.ReverseContentDisplay('manage_settings');\" name=\"h_6\">Open/Close The Console For Managing Settings</a></h3>
";
		echo "<div id=\"manage_settings\" ".$current_display.">
         <div class=\"bdiv_style_clnkr\">
";

		$radio_ena = "";
		$radio_dis = "";
		if($clnkrObj->get_is_enabled_val()=='ena')
			$radio_ena = " checked=\"checked\" ";
				else
					$radio_dis = " checked=\"checked\" ";

		echo "<p>This section offers modification of settings, feel free to setup your Cross-Linker as per your requirements</p>
							<div>
							<form name=\"formsetting\" id=\"formSettingsCrosslinker\">
<!--OBSOLETE   <input type='checkbox' name='link_to_thrusites' ".$checked." /> Link to <a href=\"http://www.aqua-fish.net/\">Aqua-Fish.Net</a>? (recommended)<br />-->
   <select name=\"core_s\" id=\"core_s\" title=\"Select core of Cross-Linker\">
   ".$core_selection."
   </select><label for=\"core_s\">Use this core</label>!<br />".$clnkrObj->insert_hr_clnkr()."
	<input type=\"radio\" name=\"turnon_off\" id=\"turnoff1\" value=\"ena\" ".$radio_ena." title=\"Enable Cross-Linker automatically\" /> <label for=\"turnoff1\">Cross-Linker is ENABLED by default</label><br />
	<input type=\"radio\" name=\"turnon_off\" id=\"turnoff2\" value=\"dis\" ".$radio_dis." title=\"Disable Cross-Linker by default\" /> <label for=\"turnoff2\">Cross-Linker is DISABLED by default</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type=\"text\" name=\"priority_clnk\" id=\"priority_clnk\" value=\"".$clnkrObj->crosslinker_priority()."\" size=\"3\" title=\"Defines priority of Cross-Linker when loading your website\" placeholder=\"10\" required /> <label for=\"priority_clnk\">Define priority of Cross-Linker. Modify this value if other plugins have to be executed before Cross-Linker. [10 is default; 1 is high; 100 is low; feel free to play with this value]</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type=\"checkbox\" name=\"enable_russian\" id=\"enable_russian\" ".$checked_9." title=\"Support of Russian characters\" /> <label for=\"enable_russian\">Enable Russian language within Cross-Linker?</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type=\"checkbox\" name=\"link_first_word\" id=\"link_first_word\" ".$checked_1." title=\"Hyperlinking of 1 occurrence per word in a document\" /> <label for=\"link_first_word\">Hyperlink 1 occurrence of each word only? (could be useful; valid for 1 post/page/comment)</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='link_comments' id=\"link_comments\" ".$checked_2." title=\"Will apply Cross-Linker to comments too\" /> <label for=\"link_comments\">Apply Cross-Linker to comments?</label> (recommended)<br />".$clnkrObj->insert_hr_clnkr();
	
		$allowedWebsites	= $clnkrObj->allowedWebsites();
							
		$site					= md5( get_site_url() );
		$isAllowed			= false;
		
		$cntWebsites = count( $allowedWebsites );
		for($i = 0; $i < $cntWebsites; $i++)
			if( $site == $allowedWebsites[$i] )
				$isAllowed = true;
									
		if( $isAllowed === true )
			echo "
	<input type='checkbox' name='default_links' id=\"default_links\" ".$checked_11." title=\"Allow few default links?\" /> <label for=\"default_links\">Allow few default links (non-intrusive, links to family-friendly websites)?</label> (recommended as this helps keeping PRO version free of charge)<br />" . $clnkrObj->insert_hr_clnkr();
	
		echo "
	<input type='checkbox' name='link_pages' id=\"link_pages\" ".$checked_7." title=\"Cross-Linker will be applied to pages too\" /> <label for=\"link_pages\">Apply Cross-Linker to pages?</label> (recommended)<br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='link_posts' id=\"link_posts\" ".$checked_8." title=\"Cross-Linker will process posts too\" /> <label for=\"link_posts\">Apply Cross-Linker to posts?</label> (recommended)<br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='delete_option' id=\"delete_option\" ".$checked_3." title=\"Will display DELETE button within words tab\" /> <label for=\"delete_option\">Show the <em>DELETE</em> option for words &amp; languages which have been cross-linked &amp; defined?</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='limitlinkings' id='limitlinkings' ".$checked_4." onclick='crosslinker_Class.checktheboxadd(\"limitlinking\",\"limitlinkings\");'/> <label for=\"limitlinkings\">Hyperlink only</label> $show_limits <label for=\"limitlinking\">occurrence(s) within a post/page/comment?</label> (may be useful; bear in mind that this feature restricts linking of each phrase per post/page/comment, not of all phrases together!) This setting will be overriden if the setting above is being used! (setting called <i>Hyperlink 1 occurrence of each word only</i>)<br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='limitmaxlinkings' id='limitmaxlinkings' ".$checked_10." onclick='crosslinker_Class.checktheboxadd(\"limitmaxlinking\",\"limitmaxlinkings\");'/> <label for=\"limitmaxlinkings\">Limit Cross-Linker to (automatically) link</label> a maximum of $show_maxlimits words per page? This limit carries highest priority, thus other limits will be ignored if maximum of links has been reached.<br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='link_to_permalinks' id=\"link_to_permalinks\" ".$checked_5." title=\"This allows one pick from posts when setting up new word/phrase for hyperlinking\" /> <label for=\"link_to_permalinks\">Allow <b>direct linking to posts</b>? This may waste your server's system resources if there are thousands of posts (but only when you're working with this control panel, otherwise everything will work fine - for your visitors)!!!</label><br />".$clnkrObj->insert_hr_clnkr()."
	<input type='checkbox' name='link_to_itself' id=\"link_to_itself\" ".$checked_6." title=\"Allows linking to same page\" /> <label for=\"link_to_itself\">Allow linking to the same page? For example, if you've configured the word <b>seo</b> to link to <b>http://www.something.tld/seo</b>, this word isn't hyperlinked on <b>http://www.something.tld/seo</b> by default. By activating this option, our imaginary word <b>seo</b> will be hyperlinked too when people visit <b>http://www.something.tld/seo</b>; Although it will point to itself only.</label><br />".$clnkrObj->insert_hr_clnkr()."
	<!--obsolete since 3.0.1.4<input type=\"text\" name=\"cdata_name\" value=\"".$clnkrObj->cl_data_filename()."\" readonly=\"readonly\" title=\"Predefined file name - This field cannot be modified\" /> Name of file which keeps Cross-Linker data. This is optional, however this file could speed up Cross-Linker as it loads data from file instead of a database. Current screen always uses database, however each time you perform a change here, all relevant data could be saved in a text file automatically, and when visitors visit regular pages of your site, Cross-Linker will load data from that file which is <b>much faster</b> than access to database-stored data! Name of this file cannot be manually modified due to security reasons, and you should create it in the directory <b>".dirname(__FILE__)."</b> on your server! When you create this file, <b>it can be blank</b> - it doesn't matter at all since it's going to be re-filled by Cross-Linker. Current status of file: ";

		switch ($clnkrObj->cl_data_exists()) {
			case 0:
				echo "<span style=\"color: red; font-weight: bold; font-style: italic;\">FILE DOES NOT EXIST!</span>";
				break;
			case 1:
				echo "<span style=\"color: blue; font-weight: bold; font-style: italic;\">FILE EXISTS!</span> but <span style=\"color: red; font-weight: bold; font-style: italic;\">IS NOT WRITABLE!</span>";
				break;
			case 2:
				echo "<span style=\"color: blue; font-weight: bold; font-style: italic;\">FILE EXISTS!</span> and <span style=\"color: blue; font-weight: bold; font-style: italic;\">IS WRITABLE!</span>";
				break;
		}
	
		echo " <span style=\"color: red;\">Please, note that this file may not work properly with special characters &yacute;, &#345;, &#382; and such. Ordinary English characters are OK though!</span> If you've created the file mentioned above and if you'd like to disable it - then simply remove it and Cross-Linker will use database-access only.-->";

		echo "<p><input type='hidden' name='up_set' value='1' />
	<button id=\"settingsUpdate\" title=\"Update all settings now!\">Save settings!</button></p>
   </form>
   
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>

   </div>
";

		echo "<br /><span style=\"color: red\"><b>IMPORTANT!</b></span><br />
         If you're upgrading this plugin, then there is no need to deactivate it! Just upload new files and rewrite old files.
";

		echo "</div></div></div>
";

		$current_cookie    = $_COOKIE['manage_backups'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console9\"><h3 id=\"backupsConsole\"><a onclick=\"crosslinker_Class.make_cookie('manage_backups');crosslinker_Class.ReverseContentDisplay('manage_backups');\" name=\"h_7\">Open/Close The Console For Managing Backups</a></h3>
";
		echo "<div id=\"manage_backups\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
";

		echo "<p><b>Backup of Cross-Linker</b>
";
		echo "<br />Backup is a safe way how to keep your Cross-Linker data always available. Additionally it's possible to configure your Cross-Linker to perform automatic backup if no recent backup has been done for over <i><b>x</b></i> days.</p>
";
		echo "<div>
		<input type=\"hidden\" name=\"create_backup\" value=\"1\" />
		<p><small><input type=\"checkbox\" name=\"keep_forever\" id=\"keep_forever\" title=\"This will create a backup that won't be deleted\" /><label for=\"keep_forever\"><b>Keep forever</b></label></small></p>
		<button title=\"This will create a backup immediately after clicking\" id=\"crosslinkerManualBackup\" />Create a manual backup now!</button>
		
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>
	
</div>

<hr class=\"clnkr_hr\" />
";

		echo "<p><b>Automatic backup configuration of Cross-Linker data</b></p>
";
		echo "<div><label for=\"force_backup_days\">Perform backup if there is no backup done for last</label> <input type=\"text\" name=\"force_backup_days\" id=\"force_backup_days\" value=\"".$clnkrObj->cl_maximum_period_without_backup()."\" size=\"3\" placeholder=\"999\" title=\"Put a number here\" required /> days. <label for=\"remove_old_backups\">Also keep the number of backups to less than</label> <input type=\"text\" name=\"remove_old_backups\" id=\"remove_old_backups\" value=\"".$clnkrObj->cl_maximum_backups()."\" size=\"3\" placeholder=\"10\" title=\"Put a number (of days) here\" required /> so the database won't be clogged with backups. <button title=\"Confirm this modification!\" id=\"backupPolicyMod\">Click here to confirm!</button>
							<p>(<small><span style=\"color: Blue;\">this rule doesn't apply to <i><b>keep forever</b></i> backups</span></small>)</p>
							<p>(<small><span style=\"color: Blue;\">settings above can be erased by deleting numbers in fields and by saving the settings</span></small>)</p>
							
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>
	
	</div>";

		echo "<hr class=\"clnkr_hr\" />
";

		echo "<p><b>Restore from Backup</b>
";
		echo "<br />Restoring from backup is a safe way how to restore your Cross-Linker data from the database. <span style=\"color:red\">This operation restores backup settings too!</span></p>
";

		echo "<div>
";

		echo "<div id=\"backupList1\"></div>";
								
		echo "</div>
";

		echo "<hr class=\"clnkr_hr\" />
";

		echo "<p><b>Delete a Backup</b>
";
		echo "<br />Use this function only if you really want to delete a backup of Cross-Linker related data!</p>
";

		echo "<div>
";

		echo "<div id=\"backupList2\"></div>";
	
		echo "</div>
";

		echo "</div></div></div>
";

		$current_cookie    = $_COOKIE['manage_imports'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";

		echo "<div id=\"console10\"><h3 id=\"exportsImportsConsole\"><a onclick=\"crosslinker_Class.make_cookie('manage_imports');crosslinker_Class.ReverseContentDisplay('manage_imports');\" name=\"h_8\">Open/Close The Console For Managing Imports/Exports</a></h3>
";

		echo "<div id=\"manage_imports\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
<p><span style=\"color: Red; font-weight: bold;\">Imports and exports work properly among versions 2.x and 3.x</span></p>
";

		echo "<p>This feature allows you to import/export hyperlinked URLs and words along with attributes of such links between two or more WP-based websites. Firstly you have to export data from one website and then simply import these data into another website. If exported word is already used in the target database, and if that word is active, all same exported words will be given the inactive attribute. If that already-existing word is inactive, attributes (meant as active/inactive) of exported words will be kept as in the original database. If exported word is already present in the target database, and if it points at the same URL as in the source database, no matter if such a word is active or not, it won't be imported (duplicate rows aren't needed, right?). Make sure that you don't store megabytes of data as you could experience problems when exporting these data into the textarea element. Generally, 2000 or 3000 words should be fine.</p>
";

		echo "<div style=\"padding: 1em;\">
<input type=\"hidden\" name=\"export_links_into_textfile\" value=\"1\" /><button id=\"exportCrosslinkerData\" title=\"Perform export now!\" />Click to export now!</button> <p>Please, bear in mind that export may require some time if your cross-linker contains plenty of data!</p>
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>
</div>
";
							
		echo "<div style=\"padding: 1em;\">
	<p><label for=\"import_text_links\"><b>Import - Put output from export into the textarea below</b></label></p>
	
	<textarea name=\"import_text_links\" id=\"import_text_links\" cols=\"50\" rows=\"15\" title=\"Put data from export here\" placeholder=\"Put outcome of export here in order to perform import\" required></textarea><br /><button title=\"Execute import now!\" id=\"importCrosslinkerData\" />Import now!</button>
	
	<p><b>Please, bear in mind that import may require some time if you import plenty of data!</b></p>
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>
";
		echo "</div>
";

		echo "</div></div></div>
";

		$current_cookie    = $_COOKIE['optimizedb'];
		if($current_cookie=='1')
			$current_display = "style=\"display:block; position: relative; left: 0px; top: 0px; border: 0px; padding: 0px; margin: 0px;\"";
				else
					$current_display = "class=\"adiv_style_clnkr\"";
		echo "<div id=\"console11\"><h3 id=\"dbOptimiseConsole\"><a onclick=\"crosslinker_Class.make_cookie('optimizedb');crosslinker_Class.ReverseContentDisplay('optimizedb');\" name=\"h_9\">Open/Close The Console For Optimizing Database</a></h3>
";

		echo "<div id=\"optimizedb\" ".$current_display.">
<div class=\"bdiv_style_clnkr\">
<p>Important: This feature applies to MyISAM tables. It's a 100% safe operation, however nowadays MySQL installations work with InnoDB as the default table engine. Cross-Linker uses InnoDB engine for its tables. Bear in mind that many WP installations still use MyISAM as default engine for tables.</p>
<p>This procedure will optimise MyISAM tables of your database. A long story short, this procedure will speed up access to your database if there are too many insert and delete operations being executed over any Wordpress data. Especially databases that have been created long time ago may contain lots of allocated empty spaces which slow down the process of reading/updating rows. Simply <b>click the button below</b>.</p>
	<button title=\"By clicking this button entire WP database with MyISAM tables will be optimised\" id=\"optimiseMyisamTables\">Optimise entire database with MyISAM tables now!</button>
	<p class=\"processing\"></p>
	<p class=\"outcome\"></p>
</div>
</div>
";

		//EXPORT - START
		if($clnkrObj->cl_data_exists()==2) {
			$tb1_exp = $wpdb->prefix . $table_crosslink_main;
			$tb2_exp = $wpdb->prefix . $table_crosslink_wdlng;
			$tb3_exp = $wpdb->prefix . $table_crosslink_attrb;
			$sid_exp = 0;
			$exp_sql = "SELECT ".$tb1_exp.".id, ".$tb1_exp.".link_word, ".$tb1_exp.".link_url, ".$tb1_exp.".visible, ".$tb2_exp.".lang_id, ".$tb3_exp.".attrib FROM ".$tb1_exp.", ".$tb2_exp.", ".$tb3_exp." where (".$tb1_exp.".id = ".$tb2_exp.".word_id) AND (".$tb1_exp.".visible = '1') AND (".$tb1_exp.".id > '".$sid_exp."') AND (".$tb3_exp.".id = ".$tb1_exp.".id) ORDER BY ".$tb1_exp.".id ASC LIMIT 1;";

			$autoid = 0;

			$sql = "SELECT a.id \"id\", a.visible \"vis\", a.link_word \"word\", a.link_url \"uri\", b.attrib \"attr\", REPLACE ( c.lang_id , '0' , '-1' ) \"lng\" FROM " . $wpdb->prefix . $table_crosslink_main . " a LEFT JOIN " . $wpdb->prefix . $table_crosslink_attrb . " b ON (a.id = b.id) LEFT JOIN " . $wpdb->prefix . $table_crosslink_wdlng . " c ON a.id = c.word_id WHERE a.visible = '1' ORDER BY 1 ASC;";

			//echo $sql;

			$clnkr_recs  = $wpdb->get_results($sql);
			$clnkr_r     = 0;
			$lines       = "";

			//nacitame si jazyky do premennej
			foreach ( $clnkr_recs as $clnkr_rec ) {
				$autoid++;
				$line['id']      = $autoid;
				$line['word']    = stripslashes($clnkr_rec->word);
				$line['url']     = stripslashes($clnkr_rec->uri);
				$line['visible'] = 1;
				$line['lang']    = stripslashes($clnkr_rec->lng);
				$line['attrib']  = stripslashes($clnkr_rec->attr);

				if($line['lang']=='')
					$line['lang'] = -1;
				if($line['attrib']=='')
					$line['attrib'] = "";

				$lines .= $line['id']."|".chr(9)."|".$line['word']."|".chr(9)."|".$line['url']."|".chr(9)."|".$line['visible']."|".chr(9)."|".$line['lang']."|".chr(9)."|".$line['attrib']."\n";
			}

			$fp = @fopen(dirname(__FILE__) . "/" . $clnkrObj->cl_data_filename(), 'w');
			@fwrite($fp, $lines);
			@fclose($fp);
		}
		//EXPORT - END

		echo "</div>
</div>
";
	
		echo "</div>
";

		echo "<script type=\"text/javascript\">
							
							var waitImage			= '".plugins_url( CLNKR_IMGDIR . '35.gif', __FILE__ )."';							
							var dbOptimScript		= '".plugins_url( CLNKR_PROCESSDIR . 'db_optim.php', __FILE__ )."';
							var dataExportScript	= '".plugins_url( CLNKR_PROCESSDIR . 'data_export.php', __FILE__ )."';
							var dataImportScript	= '".plugins_url( CLNKR_PROCESSDIR . 'data_import.php', __FILE__ )."';
							var backupScript		= '".plugins_url( CLNKR_PROCESSDIR . 'manual_backup.php', __FILE__ )."';
							var backupSettings	= '".plugins_url( CLNKR_PROCESSDIR . 'backup_settings.php', __FILE__ )."';
							var updateSettings	= '".plugins_url( CLNKR_PROCESSDIR . 'update_settings.php', __FILE__ )."';
							var updateCrosslink	= '".plugins_url( CLNKR_PROCESSDIR . 'update_term.php', __FILE__ )."';
							var updateIgnoredChar= '".plugins_url( CLNKR_PROCESSDIR . 'ignored_chars.php', __FILE__ )."';
							var deleteHTMLtags	= '".plugins_url( CLNKR_PROCESSDIR . 'delete_tags.php', __FILE__ )."';
							var addHTMLtagsPath	= '".plugins_url( CLNKR_PROCESSDIR . 'add_tags.php', __FILE__ )."';
							var prependPath		= '".plugins_url( CLNKR_PROCESSDIR . 'prepend.php', __FILE__ )."';
							var appendPath			= '".plugins_url( CLNKR_PROCESSDIR . 'append.php', __FILE__ )."';
							var strReplacePath	= '".plugins_url( CLNKR_PROCESSDIR . 'replace.php', __FILE__ )."';
							var blogrollImport	= '".plugins_url( CLNKR_PROCESSDIR . 'blogroll_import.php', __FILE__ )."';
							var addNewLang			= '".plugins_url( CLNKR_PROCESSDIR . 'add_language.php', __FILE__ )."';
							var backupListScript1= '".plugins_url( CLNKR_PROCESSDIR . 'list_backups_restore.php', __FILE__ )."';
							var backupListScript2= '".plugins_url( CLNKR_PROCESSDIR . 'list_backups_delete.php', __FILE__ )."';
							var ignoredCharsPath	= '".plugins_url( CLNKR_PROCESSDIR . 'list_ignored_chars.php', __FILE__ )."';
							var definedLangsPath	= '".plugins_url( CLNKR_PROCESSDIR . 'list_languages.php', __FILE__ )."';
							var linkedWordsPath	= '".plugins_url( CLNKR_PROCESSDIR . 'list_hyperlinked_words.php', __FILE__ )."';
							var deleteLangPath	= '".plugins_url( CLNKR_PROCESSDIR . 'delete_language.php', __FILE__ )."';
							var deleteCrosslinkT	= '".plugins_url( CLNKR_PROCESSDIR . 'delete_word.php', __FILE__ )."';
							var truncateCrossT	= '".plugins_url( CLNKR_PROCESSDIR . 'delete_all.php', __FILE__ )."';
							var manageCrossTerms	= '".plugins_url( CLNKR_PROCESSDIR . 'manage_terms.php', __FILE__ )."';
							var newTermPath		= '".plugins_url( CLNKR_PROCESSDIR . 'add_link.php', __FILE__ )."';
							var activateTermPath	= '".plugins_url( CLNKR_PROCESSDIR . 'deactivate_link.php', __FILE__ )."';
							var modifyLangPath	= '".plugins_url( CLNKR_PROCESSDIR . 'update_language.php', __FILE__ )."';
							var nullAttributes	= '".plugins_url( CLNKR_PROCESSDIR . 'assign_attributes.php', __FILE__ )."';
							var displayAttrs		= '".plugins_url( CLNKR_PROCESSDIR . 'display_attributes.php', __FILE__ )."';
							var deactLangPath		= '".plugins_url( CLNKR_PROCESSDIR . 'deactivate_language.php', __FILE__ )."';
							var deleteBackupPath	= '".plugins_url( CLNKR_PROCESSDIR . 'delete_backup.php', __FILE__ )."';
							var restoreBackupPath= '".plugins_url( CLNKR_PROCESSDIR . 'restore_backup.php', __FILE__ )."';
							var showHyperlConsole= '".plugins_url( CLNKR_PROCESSDIR . 'show_crosslink_console.php', __FILE__ )."';
							var statisticsElem	= '".plugins_url( CLNKR_PROCESSDIR . 'show_statistics.php', __FILE__ )."';
							var truncateCrossStat= '".plugins_url( CLNKR_PROCESSDIR . 'truncate_statistics.php', __FILE__ )."';
							var deleteCrossStat	= '".plugins_url( CLNKR_PROCESSDIR . 'truncate_all_statistics.php', __FILE__ )."';
							var doneMessage		= '<span style=\'color:green\'>Done &checkmark;</span>';
							
							crosslinker_Class.setCookie('clnkr_showstats','',-365);
";

		echo "
	
</script>
";
	}

if( !function_exists( 'get_data_file_db' ) ) {
	function get_data_file_db($sql,$i,$file_i,$lang) {
		global $cl_file_data_words, $cl_file_data_links, $cl_file_data_visib, $cl_file_data_langu, $cl_file_data_attrb, $min_id_words, $max_id_words, $wpdb;

		$ret = "";
		if( !isset( $cl_file_data_words[$i] ) )
			$cl_file_data_words[$i] = '';
			
		if($cl_file_data_words[$i]=='') {
			$ret = $wpdb->get_var($sql,0);
			//echo "sqlexec = " . $sql."<br />";
		}
			else {
				for($z=$file_i;$z<=$max_id_words;$z++)
					if( ($cl_file_data_langu[$z]==$lang) || ($cl_file_data_langu[$z]==(-1)) ) {
						$ret = $z;
						break;
					}
			}
			
		if( clnkrClass::DEBUG === TRUE ) {
			echo "<pre>get_data_file_db (" . $i . "):";
			var_dump($ret);
			var_dump($i);
			var_dump($cl_file_data_words);
			echo "</pre>";
		}

		return $ret;
	}
}

if( !function_exists( 'get_data_file_db_word' ) ) {
	function get_data_file_db_word($sql,$i) {
		global $cl_file_data_words, $wpdb;
		
		if( clnkrClass::DEBUG === TRUE ) {
			echo "<pre>" . $i;
			var_dump($cl_file_data_words);
			echo "</pre>";
		}

		if($cl_file_data_words[$i]=='') {
			$ret = $wpdb->get_var($sql,0);
			//echo "<br />".$sql."<hr />";
		}
			else {
				//echo "nosql!<br />";
				$ret = $cl_file_data_words[$i];
			}

		return $ret;
	}
}

if( !function_exists( 'get_data_file_db_url' ) ) {
	function get_data_file_db_url($sql,$i) {
		global $cl_file_data_links, $wpdb;

		if($cl_file_data_links[$i]=='') {
			$ret = $wpdb->get_var($sql,0);
			//echo "<br />".$sql."<hr />";
		}
			else {
				//echo "nosql!<br />";
				$ret = $cl_file_data_links[$i];
			}

		return $ret;
	}
}

if( !function_exists( 'prepare_crosslinker_from_qtranslate' ) ) {
	function prepare_crosslinker_from_qtranslate() {
		global $wpdb;

		$sql = "SELECT id, post_content FROM ".$wpdb->posts." WHERE ( post_content LIKE '%<!--:%' ) AND (post_content NOT LIKE '%<!--crosslink_lang=%') order by ID asc limit 1;";
		if(isset($lng_cnv))
			unset($lng_cnv);

		while($wpdb->get_var($sql,0)!='') {
			$this_id   = $wpdb->get_var($lang_d_qry,0);
			$this_post = $wpdb->get_var($lang_d_qry,1);

			$lng_cnv[] = "en";
			$lng_cnv[] = "de";
			$lng_cnv[] = "zh";

			for($i=0;$i<count($lng_cnv);$i++)
				$this_post = @str_replace("<!--:".$lng_cnv[$i]."-->","<!--:".$lng_cnv[$i]."--><!--crosslink_lang=".$lng_cnv[$i]."-->",$this_post);

			$update    = "update ".$wpdb->posts." set post_content = '".$this_post."' where ID = '".$this_id."' LIMIT 1;";
			$wpdb->query($update);

			$sql = "SELECT id, post_content FROM ".$wpdb->posts." WHERE ( post_content LIKE '%<!--:%' ) AND (post_content NOT LIKE '%<!--crosslink_lang=%') AND ( id > '".$this_id."' ) order by ID asc limit 1;";
		}
		return true;
	}
}

if( !function_exists( 'interlink_w_u_tmp' ) ) {
	function interlink_w_u_tmp($content) {
		return interlink_w_u($content,3);
	}
}

if( !function_exists( 'interlink_w_u_ord' ) ) {
	function interlink_w_u_ord($content) {
		return interlink_w_u($content,0);
	}
}

function interlink_w_u($content,$type) {
		//types: 1 = post, 2 = page, 3 = comment
		if(!isset($interlinker_process_count)) {
			global $interlinker_process_count;
			$interlinker_process_count = 0;
		}
		
		global $wpdb, $table_crosslink_main, $table_crosslink_tags, $table_crosslink_chars, $table_crosslink_setts, $table_crosslink_attrb, $table_crosslink_lngs, $table_crosslink_wdlng, $clnkrObj, $table_crosslink_stts1, $stats_update;

		//speed up the process, don't load data from the database each time this function is executed
		global $linked_word, $linked_uri, $link_attribute, $processed_load, $restrict_linking, $link_to_itself, $find_sel, $no_link_s, $no_link_e, $old_i, $nn, $cut_empty_spaces, $link_document_language;

		global $cl_file_data_words, $cl_file_data_links, $cl_file_data_visib, $cl_file_data_langu, $cl_file_data_attrb, $min_id_words, $max_id_words; //stores all data loaded from file - load only once

		global $max_all_links, $clnkr_pcs; //used in order to store variables that don't change
		
		global $clnkrMixPr;

		//povolene weby na automaticke linkovanie
		$allowedWebsites = $clnkrObj->allowedWebsites();
			
		//defaultne odkazy pre niektore weby (hash domeny, hash url, text, url, atribut, jazyk))
		$defaultLinks = $clnkrObj->defaultLinks();
		
		//REMOVE duplicate attributes if they somehow appeared in table
		$sql = "DELETE FROM " . $wpdb->prefix . $table_crosslink_attrb . " WHERE id NOT IN (SELECT id FROM ".$wpdb->prefix . $table_crosslink_main.");";
		$wpdb->query( $sql );

		$processed_load++;
		//end speed up
		
		//je stranka vhodna na linkovanie?
		$isAllowed	= false;
		$site			= md5( get_site_url() );
		$url			= md5( $clnkrObj->fullUrlNoPort() );
		
		$cntWebsites = count( $allowedWebsites );
		for($i = 0; $i < $cntWebsites; $i++)
			if( $site == $allowedWebsites[$i] )
				$isAllowed = true;
				
		if( clnkrClass::DEBUG === TRUE ) {
			echo "isAllowed<br />";
			var_dump($isAllowed);
		}
		
		if( $isAllowed === true ) {
			$myCnt = 0;
			//ak je default_links nastavene na 1, vlozime zopar odkazov (su len virtualne, t.j. pridame ich do pola na koniec)
			if( $wpdb->get_var("SELECT id FROM " . $wpdb->prefix . $table_crosslink_setts . " WHERE ( (setting = 'default_links') AND (value = '1') ) LIMIT 1;", 0)!='' ) {
				$count = count( $defaultLinks );
				
				if( clnkrClass::DEBUG === TRUE )
					echo "<!--count=" . $count . "<br />-->";
			
				for($i = 0; $i < $count; $i++) {
					if( $site == $defaultLinks[$i][0] && $url == $defaultLinks[$i][1] ) {
						$attr	= $defaultLinks[$i][4];
						$uri	= $defaultLinks[$i][3];
						$word	= $defaultLinks[$i][2];
						$lang = $defaultLinks[$i][5];
				
						$sql = "SELECT COUNT(*) FROM " . $wpdb->prefix . $table_crosslink_main . " WHERE link_word = '" . $word . "' AND visible = '1';";
						if( clnkrClass::DEBUG === TRUE )
							echo $sql . "<br />";
					
						if( $wpdb->get_var($sql, 0) == '0' ) {
							//zapamatame si slova v poli
							$rememberAttrb[$myCnt] = $attr;
							$rememberLinks[$myCnt] = $uri;
							$rememberWords[$myCnt] = $word;
							$rememberVisib[$myCnt] = '1';
							$rememberLangu[$myCnt] = $lang;
							
							$myCnt++;
							
							if( clnkrClass::DEBUG === TRUE )
								var_dump($rememberWords);
						}
					}						
				}
			}
		}
		if( clnkrClass::DEBUG === TRUE ) {
			echo "<p>hash domena: " . md5( get_site_url() ). "</p>";
			echo "<p>domena: " . get_site_url() . "</p>";
			echo "<p>hash url: " . md5( $clnkrObj->fullUrlNoPort() ) . "</p>";
			echo "<p>url: " . $clnkrObj->fullUrlNoPort() . "</p>";
		}
		/*
		hash domena: 21f9489b3fd8bf7616a0262fd0140671
		
		domena: https://www.domain.com

		hash url: 591dab97fc15d4a93f4cbee49c59e39e

		url: https://www.domain.com/url/
		*/

		//ideme updatovat statistiky?
		if(!isset($stats_update)) {
			$stats_update = $clnkrObj->save_page_stats();
			if($stats_update==0)
				$clnkrObj->init_stats();
		}

		//get maximum number of links per page
		if(!isset($max_all_links)) {
			$max_all_links = $clnkrObj->set_val("max_links_per_page",0);
			$clnkr_pcs     = 0;
		}

		$fix_me          = " remove_after_crosslinking ";

		//$old_z           = $i;

		$content         = $fix_me.$content.$fix_me;

		//lang detection
		if(!isset($link_document_language)) {
			$lang_table      = $wpdb->prefix . $table_crosslink_lngs;
			$lang_d_qry      = "SELECT id, lang_def FROM ".$lang_table." WHERE visible = '1' ORDER BY id ASC;";
			while($wpdb->get_var($lang_d_qry,0)!='') {
				$all_langs[$wpdb->get_var($lang_d_qry,0)] = $wpdb->get_var($lang_d_qry,1);
				$lang_d_qry      = "SELECT id, lang_def FROM ".$lang_table." WHERE visible = '1' AND id > '".$wpdb->get_var($lang_d_qry,0)."' ORDER BY id ASC;";
			}

			while (list($key, $value) = @each($all_langs)) {
				if(@strpos(@$clnkrObj->strtolower_utf8($content),@$clnkrObj->strtolower_utf8("<!--crosslink_lang=" . $value . "-->"))!==false)
					$lang_id = $key;
			}
			if( !isset( $lang_id ) )
				$lang_id = -1;
				
			if( $lang_id == '' )
				$lang_id = -1;
			$link_document_language = $lang_id;
		}
		//$key je cislo jazyka pre dokument
		//end lang detection

		$table           = $wpdb->prefix . $table_crosslink_setts;

		if( $processed_load < 2 ) {
			$restrict_linking= $clnkrObj->set_val("link_first_word",0);
			$link_to_itself  = $clnkrObj->set_val("link_to_itself",0);

			if($clnkrObj->set_val("limit_links",0)>0)
				$find_sel  = $clnkrObj->set_val("limit_links",0);
					else
						$find_sel  = 0;
		}

		//load data from text file
		if( ($clnkrObj->cl_data_exists()==2) && (!isset($cl_file_data_words)) ) {
			$filename = dirname(__FILE__) . "/" . $clnkrObj->cl_data_filename();
			$handle   = @fopen($filename, "r");
			$contents = @fread($handle, filesize($filename));
			@fclose($handle);
			$lines       = @explode("\n",$contents);
			$lines_count = @count($lines);
			for($i = 0; $i < $lines_count-1; $i++) {
				$lines[$i] = @str_replace(chr(10),"",$lines[$i]);
				$lines[$i] = @str_replace(chr(13),"",$lines[$i]);
				$line      = @explode("|".chr(9)."|",$lines[$i]);

				$cl_file_data_words[$line[0]] = $line[1];
				$cl_file_data_links[$line[0]] = $line[2];
				$cl_file_data_visib[$line[0]] = $line[3];
				$cl_file_data_langu[$line[0]] = $line[4];
				$cl_file_data_attrb[$line[0]] = $line[5];

				if(!isset($min_id_words))
					$min_id_words = $line[0];
				if(!isset($max_id_words))
					$max_id_words = $line[0];

				if($line[0]<$min_id_words)
					$min_id_words = $line[0];
				if($line[0]>$max_id_words)
					$max_id_words = $line[0];
			}
		}
			elseif(!isset($cl_file_data_words)) {
				if( clnkrClass::DEBUG === TRUE ) {
					echo "<p>executing sql</p>";
				}
				
				$sql = "SELECT a.id \"id\", a.visible \"vis\", a.link_word \"word\", a.link_url \"uri\", b.attrib \"attr\", REPLACE ( c.lang_id , '0' , '-1' ) \"lng\" FROM " . $wpdb->prefix . $table_crosslink_main . " a LEFT JOIN " . $wpdb->prefix . $table_crosslink_attrb . " b ON (a.id = b.id) LEFT JOIN " . $wpdb->prefix . $table_crosslink_wdlng . " c ON a.id = c.word_id WHERE a.visible = '1' ";
				
				$union = array();
				
				if( isset( $clnkrMixPr ) ) {
					//do nothing
				}
					else {
						$clnkrMixPr = true;
						//spojim polia, ak su nejake defaultne odkazy
						if( isset( $rememberWords ) ) {
							if( clnkrClass::DEBUG === TRUE ) {
								echo "<pre>";
								var_dump($rememberWords);
								echo "</pre>";
							}
							
							$cntWords = count($rememberWords);
							for($q = 0; $q < $cntWords; $q++) {
								$union[] = " UNION SELECT '##CALCID##' AS id, '" . $rememberVisib[$q] . "' AS vis, '" . $rememberWords[$q] . "' AS word, '" . $rememberLinks[$q] . "' AS uri, \"" . $rememberAttrb[$q] . "\" AS attr, \"" . $rememberLangu[$q] . "\" AS lng ";
							}
						}	
					}
					
				$unionCount = count($union);
				for($q = 0; $q < $unionCount; $q++)
					$sql .= $union[$q];
					
				$sql .= " ORDER BY 1 ASC ;";

				$clnkr_recs  = $wpdb->get_results($sql);
				$clnkr_r     = 1;
					
				if( clnkrClass::DEBUG === TRUE ) {
					echo "<pre>";
					var_dump($clnkr_recs);
					echo "</pre>";
					echo $sql;
				}
				
				//nacitame si jazyky do premennej
				foreach ( $clnkr_recs as $clnkr_rec ) {
					$cl_file_data_attrb[$clnkr_r] = stripslashes($clnkr_rec->attr);
					$cl_file_data_links[$clnkr_r] = stripslashes($clnkr_rec->uri);
					$cl_file_data_words[$clnkr_r] = stripslashes($clnkr_rec->word);
					$cl_file_data_visib[$clnkr_r] = stripslashes($clnkr_rec->vis);
					$cl_file_data_langu[$clnkr_r] = stripslashes($clnkr_rec->lng);

					if(!isset($min_id_words))
						$min_id_words = $clnkr_r;
					if(!isset($max_id_words))
						$max_id_words = $clnkr_r;

					if($clnkr_r<$min_id_words)
						$min_id_words = $clnkr_r;
					if($clnkr_r>$max_id_words)
						$max_id_words = $clnkr_r;

					$clnkr_r++;
				}
			}
		//end load data from text file
		
		$content_content = $content;
		$table           = $wpdb->prefix . $table_crosslink_main;

		if($link_document_language==(-1)) {
			$starting_sql = "SELECT id FROM " . $table . " WHERE visible = '1' ORDER BY id ASC LIMIT 1;";
			$gdfdb_lang   = -1;
$interlinker_process_count++;
		}
			else {
				$starting_sql = "SELECT " . $table . ".id FROM " . $table . ", ".$wpdb->prefix . $table_crosslink_wdlng . " WHERE ( (" . $wpdb->prefix . $table_crosslink_wdlng . ".lang_id = '" . $link_document_language . "') OR (" . $wpdb->prefix . $table_crosslink_wdlng . ".lang_id = '-1') ) AND (" . $table . ".id = ".$wpdb->prefix . $table_crosslink_wdlng . ".word_id) AND (" . $table . ".visible = '1') ORDER BY " . $table . ".id ASC LIMIT 1;";
				$gdfdb_lang = $link_document_language;
				$interlinker_process_count++;
			}

//		$i               = $wpdb->get_var($starting_sql);
		$i               = get_data_file_db($starting_sql,$min_id_words,$min_id_words,$gdfdb_lang);
		$sql             = "SELECT * FROM " . $table . " WHERE id = '" . $i . "';";
		$j               = 0;
		$table_name_attrs= $wpdb->prefix . $table_crosslink_attrb;

		$restore_content  = 0;
		$crosslinking_dis = 0;

		//remember content if crosslinking is disabled
		if($clnkrObj->get_is_enabled_val()=='dis')
			$crosslinking_dis = 1;
		if(@strpos($content_content,"<!--crosslinker:document_process=no-->")!==false)
			$crosslinking_dis = 1;
		if(@strpos($content_content,"<!--crosslinker:document_process=yes-->")!==false)
			$crosslinking_dis = 2;
		//end remember content if crosslinking is disabled

		if( ($clnkrObj->get_linking_option_vl($type,get_the_ID())!=1) || ($crosslinking_dis==1) ) {
			$restore_content = 1;
			$old_cnt_content = $content_content;
			if($crosslinking_dis == 2)
				$restore_content = 0;
		}

		if($processed_load<2) {
			while(get_data_file_db($sql,$i,$i,$gdfdb_lang)!='') {
				$j++;
				$linked_word[$j]    = $clnkrObj->un_wd($clnkrObj->strtolower_utf8(stripslashes(get_data_file_db_word("SELECT link_word FROM " . $table ." WHERE ( (id = '" . $i . "') AND (visible = '1') ) LIMIT 1;",$i))));
				$linked_uri[$j]     = $clnkrObj->un_wd(stripslashes(get_data_file_db_url("SELECT link_url FROM " . $table . " WHERE ( (id = '" . $i . "') AND (visible = '1') ) LIMIT 1;",$i)));
				$link_attribute[$j] = $clnkrObj->un_wd(stripslashes($clnkrObj->get_data_file_db_attr("SELECT attrib FROM " . $table_name_attrs . " WHERE id = '" . $i . "' LIMIT 1;",$i)));
				$cur_j = $j;
						
				if( clnkrClass::DEBUG === TRUE ) {
					echo "linked_word " . __LINE__ . " " . $linked_word[$cur_j] . "<br /> ";
				}
							
				if(strpos($linked_word[$cur_j],"'")!==false) {
					$j++;
					$linked_word[$j]    = str_replace("'","&#8217;",$linked_word[$cur_j]);
					$linked_uri[$j]     = $linked_uri[$cur_j];
					$link_attribute[$j] = $link_attribute[$cur_j];
				}
				if(strpos($linked_word[$cur_j],"’")!==false) {
					$j++;
					$linked_word[$j]    = str_replace("’","&#8217;",$linked_word[$cur_j]);
					$linked_uri[$j]     = $linked_uri[$cur_j];
					$link_attribute[$j] = $link_attribute[$cur_j];
				}

				if($cut_empty_spaces==1) {
					for($pi=$cur_j;$pi<=$j;$pi++) {
						while(@substr($linked_word[$pi],@strlen($linked_word[$pi])-1,1)==' ')
							$linked_word[$pi] = @substr($linked_word[$pi],0,@strlen($linked_word[$pi])-1);
						while(@substr($linked_word[$pi],0,1)==' ')
							$linked_word[$pi] = @substr($linked_word[$pi],1,@strlen($linked_word[$pi])-1);
						while(@substr($linked_uri[$pi],@strlen($linked_uri[$pi])-1,1)==' ')
							$linked_uri[$pi] = @substr($linked_uri[$pi],0,@strlen($linked_uri[$pi])-1);
						while(@substr($linked_uri[$pi],0,1)==' ')
							$linked_uri[$pi] = @substr($linked_uri[$pi],1,@strlen($linked_uri[$pi])-1);
					}
				}

				if($link_document_language==(-1)) //original - bez visible = '1' nizsie
					$next_sql = "SELECT id FROM " . $table . " WHERE (id > '" . $i . "') AND (visible = '1') ORDER BY id ASC LIMIT 1;";
						else
							$next_sql = "SELECT " . $table . ".id FROM " . $table . ", ".$wpdb->prefix . $table_crosslink_wdlng . " WHERE ( (" . $wpdb->prefix . $table_crosslink_wdlng . ".lang_id = '" . $link_document_language . "') OR (" . $wpdb->prefix . $table_crosslink_wdlng . ".lang_id = '-1') ) AND (" . $table . ".id = ".$wpdb->prefix . $table_crosslink_wdlng.".word_id) AND (" . $table . ".visible = '1') AND (" . $table . ".id > '".$i."') ORDER BY " . $table . ".id ASC LIMIT 1;";


				$i   = get_data_file_db($next_sql,$i,($i+1),$gdfdb_lang);
				$sql = "SELECT id FROM " . $table . " WHERE id = '" . $i . "';";
			}
			$change = 1;
			$i      = $j;
			$old_i  = $j;
			while($change == 1) {
				$change = 0;
				for($j=1;$j<$i;$j++) {
					if( @strlen($linked_word[$j]) < @strlen($linked_word[($j+1)]) ) {
						$t1                  = $linked_word[($j+1)];
						$linked_word[($j+1)] = $linked_word[$j];
						$linked_word[$j]     = $t1;

						$t1                  = $linked_uri[($j+1)];
						$linked_uri[($j+1)]  = $linked_uri[$j];
						$linked_uri[$j]      = $t1;

						$t1                     = $link_attribute[($j+1)];
						$link_attribute[($j+1)] = $link_attribute[$j];
						$link_attribute[$j]     = $t1;

						$change              = 1;
					}
				}
			}
		}

		$t2  = $wpdb->prefix . $table_crosslink_chars;

		if($processed_load<2) {
			$dividers_sql = "SELECT id, tag_1, tag_2 FROM " . $t2 . " ORDER BY id;";

			$divide_rec = $wpdb->get_results($dividers_sql);
			if($divide_rec) {
				$nn = 0;
				foreach ( $divide_rec as $div_r ) {
					$nn++;
					$no_link_s[$nn] = $div_r->tag_1;
					$no_link_e[$nn] = $div_r->tag_2;
				}
			}

			$no_link_s[$nn] = "<!--nocrosslink_end-->";
			$no_link_e[$nn] = "<!--nocrosslink_start-->";
			$nn++;
		}

		for($j=1;$j<=$old_i;$j++) {
			$r_extra      = 0;
			$starting_pos = 0;

			while(@strpos($clnkrObj->strtolower_utf8($content_content),$linked_word[$j],$starting_pos)!==false) {
				$temporary_uri= $linked_uri[$j];
				$previous_pos = $starting_pos - @strlen($linked_word[$j]);
				$starting_pos = @strpos($clnkrObj->strtolower_utf8($content_content),$linked_word[$j],$starting_pos) + @strlen($linked_word[$j]);
				$remain       = @substr($content_content,$starting_pos);
				$presiel      = 1;

				for($x=1;$x<$nn;$x++) {
					if(@strpos($clnkrObj->strtolower_utf8($remain),$no_link_s[$x])!==false) {
						if(@strpos($clnkrObj->strtolower_utf8($remain),$no_link_e[$x])===false)
							$presiel = 0;
								else {
									if(@strpos($clnkrObj->strtolower_utf8($remain),$no_link_s[$x])<@strpos($clnkrObj->strtolower_utf8($remain),$no_link_e[$x]))
										$presiel = 0;
								}
					}
				}

				$remember_slash = "";
				if($temporary_uri[(@strlen($temporary_uri)-1)]=='/') {
					$remember_slash = "/";
					$temporary_uri  = @substr($temporary_uri,0,(@strlen($temporary_uri)-1));
				}
						
				if($presiel==1) {
					$new_slash  = 0;
					while(@strpos($temporary_uri,"/",$new_slash)!==false)
						$new_slash = @strpos($temporary_uri,"/",$new_slash) + 1;
					$point_to   = @substr($temporary_uri,$new_slash);

					$this_uri   = $_SERVER['REQUEST_URI'];

					$remember_slash1 = "";
					if($this_uri[(@strlen($this_uri)-1)]=='/') {
						$this_uri = @substr($this_uri,0,(@strlen($this_uri)-1));
					}

					$new_slash  = 0;
					while(@strpos($this_uri,"/",$new_slash)!==false)
						$new_slash = @strpos($this_uri,"/",$new_slash) + 1; // +1 lebo / ma dlzku 1
							$current_uri = @substr($this_uri,$new_slash);

					$var             = "post:";
					$new_point_to    = $point_to;
					$is_the_same_uri = 0;
					if(@substr($point_to,0,strlen($var))==$var) {
						$pageURL = 'http';
						if ($_SERVER["HTTPS"] == "on")
							{ $pageURL .= "s"; }
						$pageURL .= "://";
						$real_current_uri = $pageURL . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
						if($real_current_uri == $clnkrObj->assign_correct_uri($point_to))
							$is_the_same_uri = 1;
								else
									$is_the_same_uri = 0;
					}
						else
							$is_the_same_uri = 0;

					if( ( ($clnkrObj->assign_correct_uri($point_to)==$current_uri)&&($link_to_itself!=1) ) || (($link_to_itself!=1)&&($is_the_same_uri==1)) ) {
						$presiel = 0;
					}
				}

				$z  = 1;

				$t3 = $wpdb->prefix . $table_crosslink_tags;

				$upgrade_fatal_01 = $wpdb->get_var("SELECT characters FROM " . $t3 . " WHERE id = 1 LIMIT 1;",0);
				if($upgrade_fatal_01[0]!=' ')
					$upgrade_fatal_01 = " ".$upgrade_fatal_01;
				$ending_part                        = @explode(" ", $upgrade_fatal_01);
				$ending_part_t                      = $wpdb->get_var("SELECT characters FROM " . $t3 . " WHERE id = '1' LIMIT 1;",1);
				$ending_part[@count($ending_part)]  = " ";
				$ending_part[@count($ending_part)]  = chr(10);

				$z                                = @count($ending_part);
				$found_z                          = 0;

				for($l=1;$l<$z;$l++)
					if($content_content[($starting_pos)]==$ending_part[$l])
						$found_z = 1;

				$found_z1         = 0;
				for($l=1;$l<$z;$l++)
					if($content_content[($starting_pos-@strlen($linked_word[$j])-1)]==$ending_part[$l])
						$found_z1 = 1;

				if(($found_z!=1)||($presiel!=1)||($found_z1!=1))
					$presiel = 0;

				if($presiel==1) {
					$r_extra++;
					$original_word    = @substr($content_content,$starting_pos-@strlen($linked_word[$j]),@strlen($linked_word[$j]));
					$supplemental     = $original_word;

					$old_part         = @substr($content_content,($previous_pos+@strlen($linked_word[$j])),($starting_pos-$previous_pos-@strlen($linked_word[$j])));
					$new_part         = @str_replace($supplemental,"<a href=\"" . $clnkrObj->assign_correct_uri($temporary_uri . $remember_slash) . "\" " . $link_attribute[$j] . ">" . $supplemental . "</a>", $old_part);
					$starting_pos     = @strlen($new_part)-@strlen($old_part)+$starting_pos;

					$found_invalid_code = 0;
					
					if(($find_sel!=0)&&($find_sel<$r_extra))
						$stop_linking = 1;
							else
								$stop_linking = 0;

					//je dosiahnuty maximalny pocet odkazov na stranku?
					if( ($max_all_links>0) && ($clnkr_pcs>=$max_all_links) )
						$stop_linking = 1;

					$can_link_to_src = 0;
					if( ( ( ($restrict_linking==1) && ($r_extra<2) ) || ($restrict_linking==0) ) && ( $stop_linking == 0 ) && ( $found_invalid_code == 0 ) ) {
						//ulozime si informacie o tom, ake slovo sme prelinkovali
						if($stats_update==1) {
							$clnkrObj->save_word_id($linked_word[$j],$link_document_language);
						}
						$can_link_to_src = 1;
						$content_content = @str_replace($old_part,$new_part,$content_content);
						$clnkr_pcs++;
					}
				}
			}
		}

		if($restore_content == 1)
			$content_content = $old_cnt_content;

		$content_content = str_replace($fix_me,"",$content_content);

		return $content_content;
	}

 $processed_load = 0;

 //core settings
 $settings_table   = $wpdb->prefix . $table_crosslink_setts;
 $cut_empty_spaces = $clnkrObj->set_val("cut_empty_spaces",0);
 //end core settings

 $clnkrObj->table_interlinker_install();
// $clnkrObj->remove_crosslinker_tags(); //remove all crosslinker tags from posts
// prepare_crosslinker_from_qtranslate(); //conversion of qtranslate -> crosslinker

 if(function_exists('add_filter')) {

	add_filter('the_content','interlink_w_u_ord', $clnkrObj->crosslinker_priority());
	$t4 = $wpdb->prefix . $table_crosslink_setts;

	if(($wpdb->get_var("SELECT id FROM " . $t4 . " WHERE ( (setting = 'link_comments') AND (value = '1') ) LIMIT 1;",0)!='')&&(function_exists('comment_text'))) {
		add_filter('comment_text','interlink_w_u_tmp', $clnkrObj->crosslinker_priority());
	}
}

	//pridame meta tag na to, aby som vedel, kde sa plugin pouziva
	add_action('admin_head', array ($clnkrObj, 'informUsage'));
	
	//pridame meta tag na stranky, ale nechceme sledovat uzivatelov
	add_action('wp_head', array ($clnkrObj, 'informAboutPlugin'));

	//pridame stylesheet
	add_action('admin_head', array ($clnkrObj, 'clnkr_stylesheet') );

	$clnkrTime['end'] = $clnkrObj->microtime_float();

	//pridame cas skriptu
	add_action('admin_head', array ($clnkrObj, 'script_exectime') );
	
	//pridame odkaz na settings v plugins stranke
	function crosslinkerPluginAddSettingsLink( $links ) {
		$links[] = '<a href="/wp-admin/tools.php?page=crosslinker">' . __( 'Settings' ) . '</a>';
		//array_push( $links, $settings_link );
		return $links;
	}
	
	$plugin = plugin_basename( __FILE__ );
	add_filter( "plugin_action_links_" . $plugin, 'crosslinkerPluginAddSettingsLink' );
	
	//pridam odkaz do hlavneho navigacneho menu	
	add_action( 'admin_menu', array ($clnkrObj, 'register_custom_menu_link') );

?>